-- char-bowser

-- Model by wibblus

E_MODEL_BOWSER_PLAYER = smlua_model_util_get_id("bowser_player_geo")
E_MODEL_BOWSER_SHELL = smlua_model_util_get_id("bowser_shell_geo")
texStockBowser = get_texture_info("hud-stock-bowser")
texMenuCharBowser = get_texture_info("menu-icon-bowser")

function bowser_mario_update(m)
    m.vel.y = m.vel.y - 1
end

function bowser_before_mario_update(m)

end

function bowser_stock_render(x, y, i, palTbl)
    network_player_palette_to_color(gNetworkPlayers[i], PANTS, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockToadBase, x, y, 1, 1)
    network_player_palette_to_color(gNetworkPlayers[i], CAP, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockBowser, x, y, 1, 1)
end

function bowser_on_hud_render()

end

function act_bowser_jab(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    
    if (step == GROUND_STEP_NONE) then

        m.vel.x = m.vel.x * 0.8
        m.vel.z = m.vel.z * 0.8

        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
            m.faceAngle.y = m.intendedYaw
        elseif (m.actionState == 1) then -- Punch 1 Start -- Hitbox
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH)
            
            if e.animFrame < 2 then
                m.faceAngle.y = m.intendedYaw
            end
            
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 3.8, -6, 10, sins(m.faceAngle.y)*150, 75, coss(m.faceAngle.y)*150, 0, 0, 0, ATTACH_RELATIVE, 5, 0)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                e.animFrame = 0
            end
        elseif (m.actionState == 2) then -- Punch 1 End
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH_FAST)
            e.animFrame = e.animFrame + 1

            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 3
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 3) then -- Punch 2 Start -- Hitbox --
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 6.2, 40, 10, sins(m.faceAngle.y)*170, 75, coss(m.faceAngle.y)*170, 0, 0, 0, ATTACH_RELATIVE, 5, 1.4)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 4
                e.animFrame = 0
            end
            
        elseif (m.actionState == 4) then -- Punch 2 End
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH_FAST)
            e.animFrame = e.animFrame + 1
        end

        if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            set_mario_action(m, ACT_IDLE, 0)
        end

        

    elseif (step == GROUND_STEP_LEFT_GROUND) then
        set_mario_action(m, ACT_DOUBLE_JUMP, 2)
    end
end

function act_bowser_aerial(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    update_air_without_turn(m)

    if (step == AIR_STEP_NONE) then
        if m.actionState == 0 then
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH)
            e.animFrame = e.animFrame + 0.5

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.3, 8.4, 38, 15, sins(m.faceAngle.y)*170, 75, coss(m.faceAngle.y)*170, 0, 0, 0, ATTACH_RELATIVE, 8, 1.4)
            end
            
            --m.marioObj.header.gfx.angle.y = m.faceAngle.y+m.actionTimer*(13000-(m.actionTimer*420))+0x8000
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd-1 then
                m.actionState = 1
                e.animFrame = 0
            end
            
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH_FAST)
            e.animFrame = e.animFrame + 0.5
            if m.actionTimer == 20 then
                set_mario_action(m, ACT_FREEFALL, 0)
            end
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_WALKING, 0)
    end
end

function act_bowser_ground_pound(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == AIR_STEP_NONE) then
        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
        elseif (m.actionState == 1) then
            set_mario_animation(m, MARIO_ANIM_START_GROUND_POUND)
            m.vel.x = m.vel.x * 0.95
            m.vel.y = 8
            m.vel.z = m.vel.z * 0.95
            e.animFrame = e.animFrame + (e.animFrame*0.2) + 0.5
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd+10 then
                m.actionState = 2
                m.actionTimer = 0
            end
        elseif (m.actionState == 2) then
            -- Create Hitbox
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.4, 22.4, 32, 280, 0, -50, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.5)
            m.actionState = 3
        elseif (m.actionState == 3) then
            m.vel.x = 0
            m.vel.y = -140
            m.vel.z = 0
            -- Create Hitbox
            --if m.actionTimer == 2 then
            --    create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 4.8, 32, 75, 0, -70, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.2)
            --end
            m.actionState = 3
        end

        if (m.controller.buttonPressed & A_BUTTON) ~= 0 and e.groundPoundA then
            e.groundPoundA = false
            m.faceAngle.y = m.intendedYaw
            set_mario_action(m, ACT_GROUND_POUND_A, 0)--gCharData[m.character.type].groundPoundA(m)
        end

        if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            set_mario_action(m, ACT_GROUND_POUND_B, 0)--gCharData[m.character.type].groundPoundB(m)
        end

    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_GROUND_POUND_LAND, 0)
        m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
    end
end

function act_bowser_ground_pound_a(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if m.actionTimer == 0 then
        m.vel.y = 32
    end
    m.actionTimer = m.actionTimer + 1
    
    if (step == AIR_STEP_NONE or step == AIR_STEP_HIT_WALL) then
        obj_set_model_extended(m.marioObj, E_MODEL_BOWSER_SHELL)
        m.vel.y = m.vel.y + 1
        if m.actionTimer % 3 == 0 then
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.3, 1.2, m.forwardVel, 20, 0, 60, 0, 0, 0, 0, ATTACH_RELATIVE, 2, 1.1)
        end
        --mario_set_forward_vel(m, m.forwardVel)
        m.faceAngle.y = m.intendedYaw
        m.vel.x = lerp(m.vel.x, (m.intendedMag*1.5)*sins(m.intendedYaw), 0.1)
        m.vel.z = lerp(m.vel.z, (m.intendedMag*1.5)*coss(m.intendedYaw), 0.1)
        if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
            m.vel.y = m.vel.y + 3
        end
        m.vel.y = m.vel.y + 3
        m.marioObj.header.gfx.angle.y = m.faceAngle.y+m.actionTimer*(13000-(m.actionTimer*420))+0x8000
        if m.actionTimer == 20 then
            mario_set_forward_vel(m, math.sqrt(sqrf(m.vel.x)+sqrf(m.vel.z)))
            set_mario_action(m, ACT_FREEFALL, 0)
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_WALKING, 0)
    end
end

function act_bowser_ground_pound_b(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if (step == AIR_STEP_NONE) then
        if m.actionState == 0 then
            m.faceAngle.y = m.intendedYaw
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 9.2, 24, 340, 0, 0, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.2)
            mario_set_forward_vel(m, 36)
            m.vel.y = 24
            m.actionState = 1
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_DIVE)

            if m.marioObj.header.gfx.animInfo.animFrame < m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                e.animFrame = e.animFrame + 1
            end

            mario_set_forward_vel(m, 36)
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x400, 0x400)
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
    end
end

function act_bowser_slide_kick(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    m.actionTimer = m.actionTimer + 1
    e.animFrame = e.animFrame + 1
    
    if (step == GROUND_STEP_NONE or step == GROUND_STEP_HIT_WALL) then
        if m.actionState == 0 then
            set_mario_animation(m, MARIO_ANIM_WALK_PANTING)
            --play_sound(SOUND_AIR_BOWSER_SPIT_FIRE, m.marioObj.header.gfx.cameraToObject)
            m.actionState = 1
        elseif m.actionState == 1 then
            mario_set_forward_vel(m, m.forwardVel * 0.6)
            cur_obj_play_sound_2(SOUND_AIR_BOWSER_SPIT_FIRE)
            if (m.actionTimer % 2 == 0 and m.actionTimer < 600) then --+(m.controller.stickY/8)
                create_hitbox(m, E_MODEL_RED_FLAME, SOUND_GENERAL_FLAME_OUT, 0.3, 0.8, 8, 15, sins(m.faceAngle.y)*120, 30, coss(m.faceAngle.y)*120, sins(m.faceAngle.y)*35, 10, coss(m.faceAngle.y)*35, ATTACH_PROJECTILE, 14-min(7, m.actionTimer*0.02), 0)
            end
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x200, 0x200)

            if (m.actionTimer > 40 and m.marioObj.header.gfx.animInfo.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd and (m.controller.buttonDown & (B_BUTTON | Z_TRIG)) == 0) then
                e.animFrame = 0
                m.actionState = 2--set_mario_action(m, ACT_IDLE, 0)
            end
        elseif m.actionState == 2 then
            set_mario_animation(m, MARIO_ANIM_SLIDEFLIP_LAND)
            e.animFrame = e.animFrame - 0.3
            m.marioObj.header.gfx.angle.y = m.faceAngle.y + 0x8000
            if (m.marioObj.header.gfx.animInfo.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd) then
                set_mario_action(m, ACT_IDLE, 0)
            end
        end
        
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
    if m.marioObj.header.gfx.animInfo.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
        e.animFrame = 0
    end
end

function act_bowser_dash(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    m.actionTimer = m.actionTimer + 1
    if (step == GROUND_STEP_NONE) then
        if m.actionState == 0 then
            mario_set_forward_vel(m, 70)
            m.actionState = 1
            
        elseif m.actionState == 1 then
            obj_set_model_extended(m.marioObj, E_MODEL_BOWSER_SHELL)
            m.marioObj.header.gfx.pos.y = m.pos.y -60
            m.marioObj.header.gfx.angle.y = m.faceAngle.y-0x800*(m.forwardVel-8)
            mario_set_forward_vel(m, m.forwardVel * 0.95)
            
            if m.actionTimer % 3 == 0 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.3, 1.2, m.forwardVel, 15, sins(m.faceAngle.y)*60, 50, coss(m.faceAngle.y)*60, 0, 0, 0, ATTACH_RELATIVE, 2, 0)
            end
            if m.actionTimer > 10 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.4, 9.6, 38, 35, sins(m.faceAngle.y)*150, 50, coss(m.faceAngle.y)*150, 0, 0, 0, ATTACH_RELATIVE, 8, 0.2)
                m.actionState = 2
            end
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x200, 0x200)
        elseif m.actionState == 2 then
            m.marioObj.header.gfx.angle.y = m.faceAngle.y-0x800*(max(0, m.forwardVel-12))
            set_mario_animation(m, MARIO_ANIM_WALK_PANTING)
            mario_set_forward_vel(m, m.forwardVel * 0.9)
            e.animFrame = e.animFrame + 3
            if (m.controller.buttonDown & A_BUTTON) ~= 0 and m.forwardVel < 24 then
                set_mario_action(m, ACT_JUMP, 0)
            end
            if m.forwardVel <= 8 then--e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                set_mario_action(m, ACT_IDLE, 0)
            end
        end
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

palBowser = {
    [1] = {
        [PANTS] = 0x23AE46,     -- Head
        [SHIRT] = 0xFFA746,     -- Body/Arms
        [GLOVES] = 0x000000,    -- ????
        [SHOES] = 0x000000,     -- ????
        [HAIR] = 0xFF2B46,      -- Hair
        [SKIN] = 0xFFBA84,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
    [2] = {
        [PANTS] = 0x237465,     -- Head
        [SHIRT] = 0xD38256,     -- Body/Arms
        [GLOVES] = 0x000000,    -- ????
        [SHOES] = 0x000000,     -- ????
        [HAIR] = 0xDB6770,      -- Hair
        [SKIN] = 0xF9A87C,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
    [3] = {
        [PANTS] = 0x212133,     -- Head
        [SHIRT] = 0x212133,     -- Body/Arms
        [GLOVES] = 0x000000,    -- ????
        [SHOES] = 0x000000,     -- ????
        [HAIR] = 0xFF4233,      -- Hair
        [SKIN] = 0x372133,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
    [4] = { -- Blue
        [PANTS] = 0x2346AE,     -- Head
        [SHIRT] = 0x03268E,     -- Body/Arms
        [GLOVES] = 0x000000,    -- ????
        [SHOES] = 0x000000,     -- ????
        [HAIR] = 0xDFCBE6,      -- Hair
        [SKIN] = 0xFFBA84,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
    [5] = { -- Red
        [PANTS] = 0x9F2F46,     -- Head
        [SHIRT] = 0x7C2F46,     -- Body/Arms
        [GLOVES] = 0x000000,    -- ????
        [SHOES] = 0x000000,     -- ????
        [HAIR] = 0xE8A346,      -- Hair
        [SKIN] = 0xFFBA84,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
    [6] = { -- White
        [PANTS] = 0xCEE0CE,     -- Head
        [SHIRT] = 0xB6C6B6,     -- Body/Arms
        [GLOVES] = 0x000000,    -- ????
        [SHOES] = 0x000000,     -- ????
        [HAIR] = 0xEAFFEA,      -- Hair
        [SKIN] = 0xEAFFEA,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
}

smash_add_character(
    "Bowser",
    0.6,                            -- Weight (How much a part of knockback affects the character)
    1.3,                            -- Size of hurtbox
    24,                             -- Top Speed
    8,                              -- Acceleration
    2,                              -- Deceleration
    8,                              -- Friction
    texMenuCharBowser,
    E_MODEL_BOWSER_PLAYER,          -- Character Model
    CT_MARIO,                       -- Character Override
    bowser_mario_update,            -- Character Mario Update
    bowser_before_mario_update,     -- Character Before Mario Update
    bowser_stock_render,            -- Character Stock Icon Render
    bowser_on_hud_render,
    -- Actions
    act_bowser_jab,
    act_bowser_aerial,
    act_bowser_ground_pound,
    act_bowser_ground_pound_a,
    act_bowser_ground_pound_b,
    act_bowser_slide_kick,
    act_bowser_dash,
    palBowser
)