-- char-emerl

texStockEmerl = get_texture_info("hud-stock-emerl")
texStockEmerlEyes = get_texture_info("hud-stock-emerl-eyes")
texMenuCharEmerl = get_texture_info("menu-icon-emerl")
E_MODEL_EMERL = smlua_model_util_get_id("emerl_geo")

texEmerlMenuWheel = get_texture_info("hud-emerl-menu-wheel")
texEmerlMenuIcons = get_texture_info("hud-emerl-menu-icons")


for i = 0, (MAX_PLAYERS - 1) do
    local np = gNetworkPlayers[i]

    local s = gPlayerSyncTable[i]
    -- Sync Table
    -- PUNCH | DASH | SLIDE KICK | AERIAL | GROUND POUND DIVE | RECOVERY
    s.emerlData = 0x020202020202
end

emerlTemp = 0x020202020202

if mod_storage_load("EmerlData") == nil then
    mod_storage_save("EmerlData", tostring(0x020202020202)) 
else
    emerlTemp = tonumber(mod_storage_load("EmerlData"))
end

local emerlDataJab = (emerlTemp & 0xFF0000000000) >> (40)
local emerlDataDash = (emerlTemp & 0x00FF00000000) >> (32)
local emerlDataSlideKick = (emerlTemp & 0x0000FF000000) >> (24)
local emerlDataAerial = (emerlTemp & 0x000000FF0000) >> (16)
local emerlDataGroundPoundDive = (emerlTemp & 0x00000000FF00) >> (8)
local emerlDataRecover = (emerlTemp & 0x0000000000FF)

gPlayerSyncTable[0].emerlData = (emerlDataJab               << (40)) +
                                (emerlDataDash              << (32)) +
                                (emerlDataSlideKick         << (24)) +
                                (emerlDataAerial            << (16)) +
                                (emerlDataGroundPoundDive   << (8)) +
                                (emerlDataRecover           << (0))

local EMERL_JAB =               0
local EMERL_DASH =              1
local EMERL_SLIDE_KICK =        2
local EMERL_AERIAL =            3
local EMERL_GROUND_POUND_DIVE = 4
local EMERL_RECOVER =           5

local attackTbl = {
    "JAB",
    "DASH",
    "SLIDE KICK",
    "JUMP KICK",
    "GROUND POUND DIVE",
    "RECOVERY"
}


local emerlMenuState = 0
local emerlMenuType = EMERL_JAB
local emerlMenuTimer = 0

function act_emerl_menu(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    set_mario_animation(m, MARIO_ANIM_FIRST_PERSON)
    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    
    if (emerlMenuState == 0) then
        set_mario_action(m, ACT_IDLE, 0)
    end

    if (step == GROUND_STEP_NONE or step == GROUND_STEP_HIT_WALL) then

        m.vel.x = m.vel.x * 0.8
        m.vel.z = m.vel.z * 0.8
    elseif (step == GROUND_STEP_HIT_WALL) then
        set_mario_action(m, ACT_FREEFALL, 0)
        emerlMenuState = 0
    end
end

function emerl_get_data(mIndex, attack)
    local s = gPlayerSyncTable[mIndex]

    if attack == EMERL_JAB then
        return (s.emerlData & 0xFF0000000000) >> (40)
    elseif attack == EMERL_DASH then
        return (s.emerlData & 0x00FF00000000) >> (32)
    elseif attack == EMERL_SLIDE_KICK then
        return (s.emerlData & 0x0000FF000000) >> (24)
    elseif attack == EMERL_AERIAL then
        return (s.emerlData & 0x000000FF0000) >> (16)
    elseif attack == EMERL_GROUND_POUND_DIVE then
        return (s.emerlData & 0x00000000FF00) >> (8)
    elseif attack == EMERL_RECOVER then
        return (s.emerlData & 0x0000000000FF) >> (0)
    end

    -- Return Current Character (Emerl) Index
    return s.character
end

function emerl_set_data(attack, index)
    local s = gPlayerSyncTable[0]
    
    if attack == EMERL_JAB then
        emerlDataJab = index
    elseif attack == EMERL_DASH then
        emerlDataDash = index
    elseif attack == EMERL_SLIDE_KICK then
        emerlDataSlideKick = index
    elseif attack == EMERL_AERIAL then
        emerlDataAerial = index
    elseif attack == EMERL_GROUND_POUND_DIVE then
        emerlDataGroundPoundDive = index
    elseif attack == EMERL_RECOVER then
        emerlDataRecover = index
    end

    s.emerlData =   (emerlDataJab               << (40)) +
                    (emerlDataDash              << (32)) +
                    (emerlDataSlideKick         << (24)) +
                    (emerlDataAerial            << (16)) +
                    (emerlDataGroundPoundDive   << (8)) +
                    (emerlDataRecover           << (0))

    mod_storage_save("EmerlData", tostring(s.emerlData))
end



--[[emerlDataJab = emerl_get_data(gMarioStates[0].playerIndex, EMERL_JAB)
emerlDataDash = emerl_get_data(gMarioStates[0].playerIndex, EMERL_DASH)
emerlDataSlideKick = emerl_get_data(gMarioStates[0].playerIndex, EMERL_SLIDE_KICK)
emerlDataAerial = emerl_get_data(gMarioStates[0].playerIndex, EMERL_AERIAL)
emerlDataGroundPoundDive = emerl_get_data(gMarioStates[0].playerIndex, EMERL_GROUND_POUND_DIVE)
emerlDataRecover = emerl_get_data(gMarioStates[0].playerIndex, EMERL_RECOVER)
]]

--gPlayerSyncTable[0].emerlData = emerlTemp

ACT_EMERL_MENU = allocate_mario_action(ACT_FLAG_CUSTOM_ACTION)

function emerl_mario_update(m)
    local s = gPlayerSyncTable[m.playerIndex]

    if (m.controller.buttonPressed & U_JPAD) ~= 0 and m.action == ACT_IDLE then
        emerlMenuState = 1
        set_mario_action(m, ACT_EMERL_MENU, 0)
    end

    if m.action ~= ACT_EMERL_MENU then
        emerlMenuState = 0
    end
end

hook_mario_action(ACT_EMERL_MENU, act_emerl_menu)

function emerl_before_mario_update(m)
    
end

function emerl_stock_render(x, y, i, palTbl)
    network_player_palette_to_color(gNetworkPlayers[i], SHIRT, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockEmerl, x, y, 1, 1)
    network_player_palette_to_color(gNetworkPlayers[i], CAP, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockEmerlEyes, x, y, 1, 1)
end

function wrap(a, b)
    if a > b then
        return a-b
    end
    return a
end

function emerl_on_hud_render()
    djui_hud_set_color(255, 255, 255, 255)
    local m = gMarioStates[0]
    local x = 64
    local y = 64

    local stickAng = atan2s(m.controller.stickY, -m.controller.stickX)-0x4000

    local out = { x = 0, y = 0, z = 0 }
    local pos = { x = m.marioObj.header.gfx.pos.x, y = m.pos.y + 210, z = m.marioObj.header.gfx.pos.z }
    if djui_hud_world_pos_to_screen_pos(pos, out) then
        x = out.x
        y = out.y+32
    end
    if emerlMenuState == 1 then
        djui_hud_set_font(FONT_TINY)
        djui_hud_print_text(attackTbl[emerlMenuType+1], x-(djui_hud_measure_text(attackTbl[emerlMenuType+1])*0.5), y-48, 1)
        djui_hud_render_texture(texEmerlMenuWheel, x-32, y-32, 1, 1)
        local menuSegment = 0x10000/6
        emerlMenuType = (5-math.floor(((stickAng+0x8000+0x4000)/menuSegment)))

        for i=0, 5 do
            local ang = i*(360/6)+(180/6)+90
            local dist = 32
            if emerlMenuType == i and m.intendedMag >= 28 then
                dist = 38
            end
            local xOffset = math.cos(math.rad(ang))*dist
            local yOffset = math.sin(math.rad(ang))*dist

            djui_hud_render_texture_tile(texEmerlMenuIcons, x-8+xOffset, y-8+yOffset, 1, 1, i*16, 0, 16, 16)
            --djui_hud_print_text(tostring(i), x+xOffset, y+yOffset, 1)
        end
        if m.intendedMag >= 28 then
            emerlMenuTimer = emerlMenuTimer + 1
            --djui_chat_message_create(tostring(emerlSelected))
        else
            emerlMenuTimer = 0
        end
        local loadSize = math.floor((emerlMenuTimer/40)*4)
        djui_hud_set_color(0, 0, 0, 255)
        djui_hud_render_rect(x-4+coss(stickAng+0x8000)*m.intendedMag, y-4-sins(stickAng+0x8000)*m.intendedMag, 8, 8)
        djui_hud_set_color(255, 255, 255, 255)
        djui_hud_render_rect(x-loadSize+coss(stickAng+0x8000)*m.intendedMag, y-loadSize-sins(stickAng+0x8000)*m.intendedMag, loadSize*2, loadSize*2)
        if emerlMenuTimer > 40 then
            emerlMenuTimer = 0
            emerlMenuState = 2
        end
        
    elseif emerlMenuState == 2 then
        local tableLength = #gCharData
        local menuSegment = 0x10000/(tableLength)
        local emerlSelected = ((tableLength)-math.floor(((stickAng+0x8000+0x4000)/(menuSegment))))
        local charName = gCharData[emerlSelected].name
        djui_hud_set_font(FONT_TINY)
        djui_hud_print_text(charName, x-(djui_hud_measure_text(charName)*0.5), y-48, 1)

        djui_hud_render_texture(texEmerlMenuWheel, x-32, y-32, 1, 1)
        for i=1, tableLength do
            local ang = i*(360/(tableLength))+90--(180/(tableLength))+90
            local dist = 32
            if emerlSelected == i and m.intendedMag >= 28 then
                dist = 38
            end
            local xOffset = math.cos(math.rad(ang))*dist
            local yOffset = math.sin(math.rad(ang))*dist

            local palTbl = {
                r = 0, g = 0, b = 0
            }

            gCharData[i].stockRender(x-8+xOffset, y-8+yOffset, 0, palTbl)
            --djui_hud_print_text(tostring(i), x+xOffset, y+yOffset, 1)
        end
        
        if m.intendedMag >= 28 then
            emerlMenuTimer = emerlMenuTimer + 1
            --djui_chat_message_create(tostring(emerlSelected))
        else
            emerlMenuTimer = 0
        end
    
        local loadSize = math.floor((emerlMenuTimer/15)*4)
        djui_hud_render_rect(x-4+coss(stickAng+0x8000)*m.intendedMag, y-4-sins(stickAng+0x8000)*m.intendedMag, 8, 8)
        djui_hud_set_color(255, 255, 255, 255)
        djui_hud_render_rect(x-loadSize+coss(stickAng+0x8000)*m.intendedMag, y-loadSize-sins(stickAng+0x8000)*m.intendedMag, loadSize*2, loadSize*2)

        if emerlMenuTimer > 15 then
            emerl_set_data(emerlMenuType, emerlSelected)
            emerlMenuState = 0
        end
    end
end

function act_emerl_jab(m)

    -- If Emerl Has Copied an Attack, Then Perform That Attack.
    local s = gPlayerSyncTable[m.playerIndex]

    local charTbl = gCharData[s.character]

    local copyAttackIndex = emerl_get_data(m.playerIndex, EMERL_JAB)

    local copyCharTbl = gCharData[copyAttackIndex]

    if copyAttackIndex ~= charTbl.charId then
        copyCharTbl.jab(m)
        return
    end

    -- Otherwise Perform Emerl's Jab.

    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    
    if (step == GROUND_STEP_NONE) then

        m.vel.x = m.vel.x * 0.8
        m.vel.z = m.vel.z * 0.8

        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
            m.faceAngle.y = m.intendedYaw
        elseif (m.actionState == 1) then -- Punch 1 Start -- Hitbox
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH)
            
            if e.animFrame < 2 then
                m.faceAngle.y = m.intendedYaw
            end
            
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.6, 1.2, -6, -20, sins(m.faceAngle.y)*100, 75, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 0.2)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                e.animFrame = 0
            end
        elseif (m.actionState == 2) then -- Punch 1 End
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH_FAST)
            e.animFrame = e.animFrame + 1

            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 3
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 3) then -- Punch 2 Start -- Hitbox --
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.4, 1.2, 6, -20, sins(m.faceAngle.y)*100, 75, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 0.2)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 4
                e.animFrame = 0
            end
            
        elseif (m.actionState == 4) then -- Punch 2 End
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH_FAST)
            e.animFrame = e.animFrame + 1
            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 5
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 5) then -- Kick End      -- Hitbox --
            set_mario_animation(m, MARIO_ANIM_TWIRL)
            m.marioObj.header.gfx.angle.y = e.animFrame * 0x1000
            e.animFrame = e.animFrame + 2

            -- Create Hitbox
            if e.animFrame == 6 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, 5, 32, 26, sins(m.faceAngle.y)*100, 85, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 8, 1.4)
            end
        end

        if e.animFrame >= 16 then
            set_mario_action(m, ACT_IDLE, 0)
        end

    elseif (step == GROUND_STEP_LEFT_GROUND) then
        set_mario_action(m, ACT_DOUBLE_JUMP, 2)
    end
end

function act_emerl_aerial(m)

    -- If Emerl Has Copied an Attack, Then Perform That Attack.
    local s = gPlayerSyncTable[m.playerIndex]

    local charTbl = gCharData[s.character]

    local copyAttackIndex = emerl_get_data(m.playerIndex, EMERL_AERIAL)

    local copyCharTbl = gCharData[copyAttackIndex]

    if copyAttackIndex ~= charTbl.charId then
        copyCharTbl.aerial(m)
        return
    end

    -- Otherwise Perform Emerl's Aerial.

    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    update_air_without_turn(m)
    
    if (step == AIR_STEP_NONE) then
        set_mario_animation(m, MARIO_ANIM_SLIDE_KICK)
        if m.actionTimer == 4 then
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 5.2, 38, 50, 0, 10, 0, 0, 0, 0, ATTACH_RELATIVE, 6, 0.4)
        end
        
        m.marioObj.header.gfx.angle.y = m.faceAngle.y+m.actionTimer*(13000-(m.actionTimer*420))+0x8000
        if m.actionTimer == 20 then
            set_mario_action(m, ACT_FREEFALL, 0)
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_WALKING, 0)
    end
end

function act_emerl_ground_pound(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == AIR_STEP_NONE) then
        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
            m.vel.y = 2
        elseif (m.actionState == 1) then
            set_mario_animation(m, MARIO_ANIM_START_CROUCHING)
            m.vel.x = m.vel.x * 0.7
            m.vel.y = 4
            m.vel.z = m.vel.z * 0.7
            e.animFrame = e.animFrame + (e.animFrame*0.2) + 0.5
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                m.actionTimer = 0
            end
        elseif (m.actionState == 2) then
            set_mario_animation(m, MARIO_ANIM_GENERAL_FALL)
            -- Create Hitbox
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, 8.6, 32, 280, 0, -50, 0, 0, 0, 0, ATTACH_RELATIVE, 6, 1.5)
            m.actionState = 3
        elseif (m.actionState == 3) then
            m.vel.x = 0
            m.vel.y = -96
            m.vel.z = 0
            -- Create Hitbox
            if m.actionTimer == 2 then
                --create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 2.4, 32, -80, 0, -70, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.2)
            end
            m.actionState = 3
        end

        if (m.controller.buttonPressed & A_BUTTON) ~= 0 and e.groundPoundA then
            e.groundPoundA = false
            set_mario_action(m, ACT_GROUND_POUND_A, 0)--gCharData[m.character.type].groundPoundA(m)
        end

        if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            set_mario_action(m, ACT_GROUND_POUND_B, 0)--gCharData[m.character.type].groundPoundB(m)
        end

    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_GROUND_POUND_LAND, 0)
        m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
    end
end

function act_emerl_ground_pound_a(m)
    -- If Emerl Has Copied an Attack, Then Perform That Attack.
    local s = gPlayerSyncTable[m.playerIndex]

    local charTbl = gCharData[s.character]

    local copyAttackIndex = emerl_get_data(m.playerIndex, EMERL_RECOVER)

    local copyCharTbl = gCharData[copyAttackIndex]

    if copyAttackIndex ~= charTbl.charId then
        copyCharTbl.groundPoundA(m)
        return
    end

    -- Otherwise Perform Emerl's Recovery.
    set_mario_action(m, ACT_DOUBLE_JUMP, 0)
    
    m.vel.y = 36
end

function act_emerl_ground_pound_b(m)

    -- If Emerl Has Copied an Attack, Then Perform That Attack.
    local s = gPlayerSyncTable[m.playerIndex]

    local charTbl = gCharData[s.character]

    local copyAttackIndex = emerl_get_data(m.playerIndex, EMERL_GROUND_POUND_DIVE)

    local copyCharTbl = gCharData[copyAttackIndex]

    if copyAttackIndex ~= charTbl.charId then
        copyCharTbl.groundPoundB(m)
        return
    end

    -- Otherwise Perform Emerl's Jab.
    
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if (step == AIR_STEP_NONE) then
        if m.actionState == 0 then
            m.faceAngle.y = m.intendedYaw
            mario_set_forward_vel(m, 60)
            m.vel.y = 32
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 8.8, 32, 24, 0, 0, 0, 0, 0, 0, ATTACH_RELATIVE, 16, 1.4)
            m.actionState = 1
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_AIRBORNE_ON_STOMACH)

            if m.marioObj.header.gfx.animInfo.animFrame < m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                e.animFrame = e.animFrame + 1
            end

            mario_set_forward_vel(m, m.forwardVel*0.95)
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x400, 0x400)
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
    elseif (step == AIR_STEP_HIT_WALL) then
        set_mario_action(m, ACT_SOFT_BONK, 0)
    end
end

function act_emerl_slide_kick(m)

    -- If Emerl Has Copied an Attack, Then Perform That Attack.
    local s = gPlayerSyncTable[m.playerIndex]

    local charTbl = gCharData[s.character]

    local copyAttackIndex = emerl_get_data(m.playerIndex, EMERL_SLIDE_KICK)

    local copyCharTbl = gCharData[copyAttackIndex]

    if copyAttackIndex ~= charTbl.charId and charTbl.name ~= "Kirby" then
        copyCharTbl.slideKick(m)
        return
    end

    -- Otherwise Perform Emerl's Slide Kick.

    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    m.actionTimer = m.actionTimer + 1
    
    if (step == GROUND_STEP_NONE or step == GROUND_STEP_HIT_WALL) then
        if m.actionState == 0 then
            set_mario_animation(m, MARIO_ANIM_WALK_PANTING)
            m.actionState = 1
        elseif m.actionState == 1 then
            e.animFrame = e.animFrame + 1 + m.actionTimer/5
            mario_set_forward_vel(m, m.forwardVel * 0.6)
            cur_obj_play_sound_2(SOUND_MOVING_TERRAIN_SLIDE)
            if (m.actionTimer > 25) then
                create_hitbox(m, E_MODEL_WATER_BOMB, SOUND_GENERAL2_BOBOMB_EXPLOSION, 0.4, 24, 40, 20, sins(m.faceAngle.y)*120, 30, coss(m.faceAngle.y)*120, sins(m.faceAngle.y)*74, 0, coss(m.faceAngle.y)*74, ATTACH_PROJECTILE, 20, 1.5)
                cur_obj_play_sound_2(SOUND_OBJ_POUNDING_CANNON)
                m.actionTimer = 0
                m.actionState = 2
            end
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x200, 0x200)

            if (m.actionTimer > 30 and m.marioObj.header.gfx.animInfo.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd and (m.controller.buttonDown & (B_BUTTON | Z_TRIG)) == 0) then
                e.animFrame = 0
                m.actionState = 2--set_mario_action(m, ACT_IDLE, 0)
            end
        elseif m.actionState == 2 then
            set_mario_animation(m, MARIO_ANIM_WALK_PANTING)
            e.animFrame = e.animFrame + 0.25
            
            if (m.marioObj.header.gfx.animInfo.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd) then
                set_mario_action(m, ACT_IDLE, 0)
            end
        end
        
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
    if m.marioObj.header.gfx.animInfo.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
        e.animFrame = 0
    end
end

function act_emerl_dash(m)

    -- If Emerl Has Copied an Attack, Then Perform That Attack.
    local s = gPlayerSyncTable[m.playerIndex]

    local charTbl = gCharData[s.character]

    local copyAttackIndex = emerl_get_data(m.playerIndex, EMERL_DASH)

    local copyCharTbl = gCharData[copyAttackIndex]

    if copyAttackIndex ~= charTbl.charId then
        copyCharTbl.dash(m)
        return
    end

    -- Otherwise Perform Emerl's Dash.

    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if (step == GROUND_STEP_NONE) then
        if m.actionState == 0 then
            mario_set_forward_vel(m, 80)
            set_mario_animation(m, MARIO_ANIM_TWIRL)
            m.marioObj.header.gfx.angle.y = e.animFrame * 0x1000
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 8.6, 48, 35, sins(m.faceAngle.y)*150, 50, coss(m.faceAngle.y)*150, 0, 0, 0, ATTACH_RELATIVE, 16, 1.3)
            m.actionState = 1
        elseif m.actionState == 1 then
            e.animFrame = e.animFrame + 2
            set_mario_animation(m, MARIO_ANIM_TWIRL)
            m.marioObj.header.gfx.angle.y = e.animFrame * 0x1000
            mario_set_forward_vel(m, m.forwardVel * 0.9)
            if e.animFrame >= 32 then
                m.actionState = 2
                m.actionTimer = 0
                e.animFrame = 0
            end
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x200, 0x200)
        elseif m.actionState == 2 then
            set_mario_animation(m, MARIO_ANIM_TWIRL_LAND)
            mario_set_forward_vel(m, m.forwardVel * 0.8)
            e.animFrame = e.animFrame + 1
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                set_mario_action(m, ACT_WALKING, 0)
            end
        end
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

palEmerl = {
    [1] = {
        [PANTS] = 0xF2933A,     -- Darker Head
        [SHIRT] = 0xFFBA6D,     -- Head
        [GLOVES] = 0xFFEBC1,    -- Pants
        [SHOES] = 0x99673E,     -- Hands
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0x000000,      -- Skin
        [CAP] = 0x37A3FF,       -- Eyes
        [EMBLEM] = 0x000000,    -- Nothing?
    },
    [2] = {
        [PANTS] = 0xFFFF00,     -- Darker Head
        [SHIRT] = 0x221144,     -- Head
        [GLOVES] = 0x221144,    -- Pants
        [SHOES] = 0x443366,     -- Hands
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0x000000,      -- Skin
        [CAP] = 0x37A3FF,       -- Eyes
        [EMBLEM] = 0x000000,    -- Nothing?
    },
    [3] = {
        [PANTS] = 0x0000F0,     -- Head
        [SHIRT] = 0xDF0022,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x893F3B,     -- ????
        [HAIR] = 0x893F3B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0xDF0022,       -- Spikes???
        [EMBLEM] = 0xDF0022,
    },
    [4] = {
        [PANTS] = 0x0000F0,     -- Head
        [SHIRT] = 0x3DD33F,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x893F3B,     -- ????
        [HAIR] = 0x893F3B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x3DD33F,       -- Spikes???
        [EMBLEM] = 0x3DD33F,
    },
    [5] = { -- Waluigi
        [PANTS] = 0x251D44,     -- Head
        [SHIRT] = 0x8352E0,     -- Body/Arms
        [GLOVES] = 0xFFCCFF,    -- ????
        [SHOES] = 0xFF7A46,     -- ????
        [HAIR] = 0x9B713B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x8352E0,       -- Spikes???
        [EMBLEM] = 0xFFC944,
    },
    [6] = { -- Wario
        [PANTS] = 0xB633DC,     -- Head
        [SHIRT] = 0xFFD946,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x3DA33F,     -- ????
        [HAIR] = 0x9B713B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0xFFD946,       -- Spikes???
        [EMBLEM] = 0x0000FF,
    },
}
smash_add_character(
    "Emerl",
    0.7,                              -- Weight (How much a part of knockback affects the character)
    1,                              -- Size of hurtbox
    68,                             -- Top Speed
    2,                              -- Acceleration
    2,                              -- Deceleration
    1.5,                            -- Friction
    texMenuCharEmerl,
    E_MODEL_EMERL,                  -- Character Model
    CT_MARIO,                       -- Character Override
    emerl_mario_update,             -- Character Mario Update
    emerl_before_mario_update,      -- Character Before Mario Update
    emerl_stock_render,             -- Character Stock Icon Render
    emerl_on_hud_render,            -- Character Hud Render
    -- Actions
    act_emerl_jab,
    act_emerl_aerial,
    act_emerl_ground_pound,
    act_emerl_ground_pound_a,
    act_emerl_ground_pound_b,
    act_emerl_slide_kick,
    act_emerl_dash,
    palEmerl
)