-- char-mario

texStockKingBobomb = get_texture_info("hud-stock-king-bobomb")
texStockKingBobombEyes = get_texture_info("hud-stock-king-bobomb-eyes")
texMenuCharKingBobomb = get_texture_info("menu-icon-king-bobomb")

E_MODEL_KING_BOBOMB_PLAYER = smlua_model_util_get_id("king_bobomb_player_geo")

function king_bobomb_mario_update(m)

end

function king_bobomb_before_mario_update(m)

end

function king_bobomb_stock_render(x, y, i, palTbl)
    network_player_palette_to_color(gNetworkPlayers[i], PANTS, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockKingBobomb, x, y, 1, 1)

    djui_hud_set_color(255, 255, 255, 255)
    djui_hud_render_texture(texStockKingBobombEyes, x, y, 1, 1)
end

function king_bobomb_on_hud_render()

end

function act_king_bobomb_jab(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    
    if (step == GROUND_STEP_NONE) then

        m.vel.x = m.vel.x * 0.8
        m.vel.z = m.vel.z * 0.8

        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
            m.faceAngle.y = m.intendedYaw
        elseif (m.actionState == 1) then -- Punch 1 Start -- Hitbox
            set_mario_animation(m, MARIO_ANIM_PICK_UP_LIGHT_OBJ)
            
            if e.animFrame < 2 then
                m.faceAngle.y = m.intendedYaw
            end
            
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 4 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 2.4, 56, 20, sins(m.faceAngle.y)*130, 75, coss(m.faceAngle.y)*130, 0, 0, 0, ATTACH_NONE, 5, 1.4)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                e.animFrame = 0
            end
        elseif (m.actionState == 2) then -- Punch 1 End
            set_mario_animation(m, MARIO_ANIM_PICK_UP_LIGHT_OBJ)
            e.animFrame = e.animFrame + 0.7
        end

        if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            set_mario_action(m, ACT_IDLE, 0)
        end

    elseif (step == GROUND_STEP_LEFT_GROUND) then
        set_mario_action(m, ACT_DOUBLE_JUMP, 2)
    end
end

function act_king_bobomb_aerial(m)

    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    
    if m.actionTimer == 0 then
        m.vel.y = 16
    end

    m.actionTimer = m.actionTimer + 1
    
    update_air_without_turn(m)

    if (step == AIR_STEP_NONE or step == AIR_STEP_HIT_WALL) then
        if m.actionState == 0 then
            
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH)
            e.animFrame = e.animFrame + 0.5

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.3, 10.4, 38, 335, sins(m.faceAngle.y)*170, 75, coss(m.faceAngle.y)*170, 0, 0, 0, ATTACH_RELATIVE, 8, 1.3)
            end
            
            --m.marioObj.header.gfx.angle.y = m.faceAngle.y+m.actionTimer*(13000-(m.actionTimer*420))+0x8000
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd-1 then
                m.actionState = 1
                e.animFrame = 0
            end
            
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH_FAST)
            e.animFrame = e.animFrame + 0.5
            m.vel.y = m.vel.y + 2
            if m.actionTimer == 20 then
                set_mario_action(m, ACT_FREEFALL, 0)
            end
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_WALKING, 0)
    end
end

function act_king_bobomb_ground_pound(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == AIR_STEP_NONE or step == AIR_STEP_HIT_WALL) then
        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
            m.vel.y = 8
        elseif (m.actionState == 1) then
            set_mario_animation(m, MARIO_ANIM_START_GROUND_POUND)
            m.vel.x = m.vel.x * 0.7
            
            m.vel.z = m.vel.z * 0.7
            e.animFrame = e.animFrame + (e.animFrame*0.2) + 0.5
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                m.actionTimer = 0
            end
        elseif (m.actionState == 2) then
            -- Create Hitbox
            --create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, 8.6, 32, 280, 0, -50, 0, 0, 0, 0, ATTACH_RELATIVE, 6, 1.5)
            m.actionState = 3
        elseif (m.actionState == 3) then
            m.vel.x = 0
            m.vel.y = -72
            m.vel.z = 0
            -- Create Hitbox
            if m.actionTimer == 2 then
                --create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 2.4, 32, -80, 0, -70, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.2)
            end
            m.actionState = 3
        end

        if (m.controller.buttonPressed & A_BUTTON) ~= 0 and e.groundPoundA then
            e.groundPoundA = false
            set_mario_action(m, ACT_GROUND_POUND_A, 0)--gCharData[m.character.type].groundPoundA(m)
        end

        if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            set_mario_action(m, ACT_GROUND_POUND_B, 0)--gCharData[m.character.type].groundPoundB(m)
        end

    elseif (step == AIR_STEP_LANDED) then
        create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.6, 14.8, 32, 40, 0, -50, 0, 0, 0, 0, ATTACH_RELATIVE, 6, 1.5)
        create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.8, 2.4, 48, 20, 0, -50, 0, 0, 0, 0, ATTACH_RELATIVE, 6, 0)
        set_mario_action(m, ACT_GROUND_POUND_LAND, 0)
        m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR | PARTICLE_MIST_CIRCLE
    end
end

function act_king_bobomb_ground_pound_a(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    --m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    if m.actionTimer == 0 and m.actionState == 0 then
        m.vel.y = 24
    end
    m.actionTimer = m.actionTimer + 1
    if (step == AIR_STEP_NONE or step == AIR_STEP_HIT_WALL) then
        if m.actionState == 0 then
            if ((m.controller.buttonDown & A_BUTTON) == 0 or m.actionTimer > 40) and m.actionTimer > 15 then
                set_mario_animation(m, MARIO_ANIM_CROUCHING)
                m.marioObj.header.gfx.animInfo.animFrame = 0
                m.faceAngle.y = m.intendedYaw
                mario_set_forward_vel(m, m.intendedMag)
                m.vel.y = 32+(m.actionTimer*2)

                --create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, m.forwardVel*0.3, m.forwardVel, 15, sins(m.faceAngle.y)*20, 50, coss(m.faceAngle.y)*20, 0, 0, 0, ATTACH_RELATIVE, m.actionTimer*0.5, 0)

                m.actionTimer = 0
                m.actionState = 1
            else
                m.faceAngle.y = m.intendedYaw
                m.vel.x = m.vel.x * 0.9
                if m.vel.y < -32 then
                    m.vel.y = m.vel.y + 4
                else 
                    m.vel.y = m.vel.y + 3
                end
                m.vel.z = m.vel.z * 0.9
            end
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_DOUBLE_JUMP_RISE)
            
            --mario_set_forward_vel(m, m.forwardVel*0.95)
            --m.vel.y = m.vel.y + 3

            if m.vel.y <= -16 then
                set_mario_action(m, ACT_FREEFALL, 0)
            end
        end
    elseif (step == AIR_STEP_LANDED) then
        if m.actionState == 0 then
            if (m.controller.buttonDown & B_BUTTON) == 0 or m.actionTimer > 60 then
                set_mario_animation(m, MARIO_ANIM_CROUCHING)
                m.marioObj.header.gfx.animInfo.animFrame = 0
                mario_set_forward_vel(m, 48+(m.actionTimer))
                m.vel.y = 40

                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, m.forwardVel*0.3, m.forwardVel, 15, sins(m.faceAngle.y)*20, 50, coss(m.faceAngle.y)*20, 0, 0, 0, ATTACH_RELATIVE, m.actionTimer*0.5, 0)

                m.actionTimer = 0
                m.actionState = 1
            else
                m.faceAngle.y = m.intendedYaw
                m.vel.x = m.vel.x * 0.9
                m.vel.z = m.vel.z * 0.9
            end
        else
            set_mario_action(m, ACT_DOUBLE_JUMP_LAND, 0)
        end
    end
end

function act_king_bobomb_ground_pound_b(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    
    if m.actionTimer == 0 then
        m.vel.y = 16
    end

    m.actionTimer = m.actionTimer + 1
    
    update_air_without_turn(m)

    if (step == AIR_STEP_NONE or step == AIR_STEP_HIT_WALL) then
        if m.actionState == 0 then
            
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH)
            mario_set_forward_vel(m, m.forwardVel*0.95)
            e.animFrame = e.animFrame + 0.5

            m.faceAngle.y = m.intendedYaw

            -- Create Hitbox
            if e.animFrame == 3 then
                if m.playerIndex == 0 then
                    spawn_sync_object(id_bhvBobombKing, E_MODEL_BLACK_BOBOMB, m.pos.x, m.pos.y, m.pos.z, function(obj) obj.oSnufitScale = s.scale obj.oVelX = m.vel.x+(sins(m.faceAngle.y)*40*s.scale) obj.oVelY = -24*s.scale obj.oVelZ = m.vel.z+(coss(m.faceAngle.y)*40*s.scale) end)
                end
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd-1 then
                m.actionState = 1
                e.animFrame = 0
            end
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH_FAST)
            e.animFrame = e.animFrame + 0.5
            m.vel.y = m.vel.y + 2
            if m.actionTimer == 20 then
                set_mario_action(m, ACT_FREEFALL, 0)
            end
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_WALKING, 0)
    end
end

function act_king_bobomb_slide_kick(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    if (m.actionTimer == 0) then
        
        mario_set_forward_vel(m, m.forwardVel*0.6)
    end
    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == GROUND_STEP_NONE) then
        mario_set_forward_vel(m, m.forwardVel*0.78)
        set_mario_animation(m, MARIO_ANIM_HEAVY_THROW)
        if (m.actionTimer == 8) then
            create_hitbox(m, E_MODEL_NONE, SOUND_GENERAL2_BOBOMB_EXPLOSION, 2.4, 4.8, 76, 280, sins(m.faceAngle.y)*20, -50, coss(m.faceAngle.y)*20, 0, 0, 0, ATTACH_NONE, 2, 1.5)
        end
        if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd-8 then
            if m.controller.buttonDown & A_BUTTON ~= 0 then
                set_mario_action(m, ACT_DOUBLE_JUMP, 0)
                m.vel.y = 60
            end
        end
    end
    e.animFrame = e.animFrame + 1
    
    if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
        set_mario_action(m, ACT_IDLE, 0)
    end
end

function act_king_bobomb_dash(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if (step == GROUND_STEP_NONE) then
        if m.actionState == 0 then
            mario_set_forward_vel(m, 96)
            set_mario_animation(m, MARIO_ANIM_DIVE)
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.4, 12, 38, 20, sins(m.faceAngle.y)*150, 50, coss(m.faceAngle.y)*150, 0, 0, 0, ATTACH_RELATIVE, 6, 1.4)
            m.actionState = 1
        elseif m.actionState == 1 then
            e.animFrame = e.animFrame + 1
            mario_set_forward_vel(m, m.forwardVel * 0.9)
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                m.actionTimer = 0
            end
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x200, 0x200)
        elseif m.actionState == 2 then
            set_mario_animation(m, MARIO_ANIM_SLOW_LAND_FROM_DIVE)
            mario_set_forward_vel(m, m.forwardVel * 0.7)
            e.animFrame = e.animFrame + 1
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                set_mario_action(m, ACT_IDLE, 0)
            end
        end
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

palKingBobomb = {
    [1] = {
        [PANTS] = 0x090029,
        [SHIRT] = 0x273AFF,
        [GLOVES] = 0xFFAA00,
        [SHOES] = 0xFFAA00,
        [HAIR] = 0xFFF0FF,
        [SKIN] = 0x000000,
        [CAP] = 0xFFAA00,
        [EMBLEM] = 0x000000,
    },
    [2] = {
        [PANTS] = 0xFF33CB,
        [SHIRT] = 0xDDBBDD,
        [GLOVES] = 0xFF2255,
        [SHOES] = 0xFF2255,
        [HAIR] = 0xFFF0FF,
        [SKIN] = 0x000000,
        [CAP] = 0xEDBBFF,
        [EMBLEM] = 0x000000,
    },
    [3] = {
        [PANTS] = 0x8000FF,
        [SHIRT] = 0xDDBBDD,
        [GLOVES] = 0xFF0030,
        [SHOES] = 0xDDBBDD,
        [HAIR] = 0xFFF0FF,
        [SKIN] = 0x000000,
        [CAP] = 0xFF0030,
        [EMBLEM] = 0x000000,
    },
    [4] = { 
        [PANTS] = 0x002780,
        [SHIRT] = 0x002780,
        [GLOVES] = 0x026D0D,
        [SHOES] = 0x026D0D,
        [HAIR] = 0xF5A314,
        [SKIN] = 0x000000,
        [CAP] = 0x002780,
        [EMBLEM] = 0x000000,
    },
    [5] = { 
        [PANTS] = 0xF77800,
        [SHIRT] = 0x002780,
        [GLOVES] = 0x5278C6,
        [SHOES] = 0x5278C6,
        [HAIR] = 0xFFF0FF,
        [SKIN] = 0x000000,
        [CAP] = 0x002780,
        [EMBLEM] = 0x000000,
    },
    [6] = { 
        [PANTS] = 0xFF6DF0,
        [SHIRT] = 0xFFF0FF,
        [GLOVES] = 0xFFF0FF,
        [SHOES] = 0x54CEFF,
        [HAIR] = 0xFFF0FF,
        [SKIN] = 0x000000,
        [CAP] = 0x54CEFF,
        [EMBLEM] = 0x000000,
    },
}

smash_add_character(
    "King Bob-omb",
    0.5,                        -- Weight (How much a part of knockback affects the character)
    1.6,                        -- Size of hurtbox
    22,                         -- Top Speed
    6,                          -- Acceleration
    6,                          -- Deceleration
    4,                          -- Friction
    texMenuCharKingBobomb,
    E_MODEL_KING_BOBOMB_PLAYER, -- Character Model
    CT_MARIO,                   -- Character Override
    king_bobomb_mario_update,         -- Character Mario Update
    king_bobomb_before_mario_update,  -- Character Before Mario Update
    king_bobomb_stock_render,         -- Character Stock Icon Render
    king_bobomb_on_hud_render,
    -- Actions
    act_king_bobomb_jab,
    act_king_bobomb_aerial,
    act_king_bobomb_ground_pound,
    act_king_bobomb_ground_pound_a,
    act_king_bobomb_ground_pound_b,
    act_king_bobomb_slide_kick,
    act_king_bobomb_dash,
    palKingBobomb
)

