-- char-kirby
texStockKirby = get_texture_info("hud-stock-kirby")
texMenuCharKirby = get_texture_info("menu-icon-kirby")
E_MODEL_KIRBY = smlua_model_util_get_id("kirby_geo")
E_MODEL_SONIC_HAT = smlua_model_util_get_id("sonic_hat_geo")

for i = 0, (MAX_PLAYERS - 1) do
    local np = gNetworkPlayers[i]

    local s = gPlayerSyncTable[i]
    -- Sync Table
    s.copyAbility = 2
    s.jumps = 0
end

function kirby_mario_update(m)
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.vel.y < -48) then
        m.vel.y = m.vel.y + 6
    elseif (m.vel.y > 48) then
        m.vel.y = m.vel.y - 6
    end

    if (m.action & ACT_FLAG_AIR) == 0 then
        s.jumps = 5
    else
        if (m.controller.buttonPressed & A_BUTTON) ~= 0 and s.jumps > 0 and (m.action & ACT_FLAG_ATTACKING) == 0 and (m.action & ACT_FLAG_AIR) ~= 0 and m.action ~= ACT_AIR_KNOCKBACK then
            s.jumps = s.jumps - 1
            set_mario_action(m, ACT_DOUBLE_JUMP, 0)
            m.vel.y = 32+((s.jumps+1)*8)
        end
    end
end

function kirby_before_mario_update(m)
    local s = gPlayerSyncTable[0]
    if (m.controller.buttonPressed & U_JPAD) ~= 0 then
        s.copyAbility = s.character
        m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
        --[[spawn_non_sync_object(
                id_bhvKirbyCap,
                E_MODEL_MARIOS_CAP,
                m.pos.x, m.pos.y, m.pos.z,
                function(obj) obj.oOpacity = 255 end)]]
    end
end

function kirby_stock_render(x, y, i, palTbl)
    network_player_palette_to_color(gNetworkPlayers[i], CAP, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockKirby, x, y, 1, 1)
end

function kirby_on_hud_render()

end

function act_kirby_jab(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    
    if (step == GROUND_STEP_NONE) then

        m.vel.x = m.vel.x * 0.7
        m.vel.z = m.vel.z * 0.7

        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
            m.faceAngle.y = m.intendedYaw
        elseif (m.actionState == 1) then -- Punch 1 Start -- Hitbox
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH)
            
            if e.animFrame < 2 then
                m.faceAngle.y = m.intendedYaw
            end
            
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 3.8, -6, 10, sins(m.faceAngle.y)*150, 75, coss(m.faceAngle.y)*150, 0, 0, 0, ATTACH_RELATIVE, 5, 0)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                e.animFrame = 0
            end
        elseif (m.actionState == 2) then -- Punch 1 End
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH_FAST)
            e.animFrame = e.animFrame + 1

            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 3
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 3) then -- Punch 2 Start -- Hitbox --
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 1.2, 6, 10, sins(m.faceAngle.y)*170, 75, coss(m.faceAngle.y)*170, 0, 0, 0, ATTACH_RELATIVE, 5, 0)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 4
                e.animFrame = 0
            end
            
        elseif (m.actionState == 4) then -- Punch 2 End
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH_FAST)
            e.animFrame = e.animFrame + 1

            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 5
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 5) then -- Rapid Jab
            e.animFrame = e.animFrame + 2

            -- Create Hitbox
            
            if (m.controller.buttonDown & B_BUTTON) == 0 and e.animFrame >= 6 then
                e.animFrame = 0
                m.actionState = 6
            end
            
            if e.animFrame >= 6 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 0.6, 2, 10, sins(m.faceAngle.y)*100, 75, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_RELATIVE, 5, 0.05)
                if m.marioObj.header.gfx.animInfo.curAnim == MARIO_ANIM_FIRST_PUNCH then
                    set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH)
                else
                    set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH)
                end
                e.animFrame = 0
            end
        elseif (m.actionState == 6) then -- Punch 2 End
            if e.animFrame == 6 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.2, 8.6, 40, 10, sins(m.faceAngle.y)*120, 75, coss(m.faceAngle.y)*120, 0, 0, 0, ATTACH_RELATIVE, 5, 1.4)
            end

            set_mario_animation(m, MARIO_ANIM_GROUND_THROW)

            e.animFrame = e.animFrame + 2
        end

        if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            set_mario_action(m, ACT_IDLE, 0)
        end

        

    elseif (step == GROUND_STEP_LEFT_GROUND) then
        set_mario_action(m, ACT_DOUBLE_JUMP, 2)
    end
end

function act_kirby_aerial(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    update_air_without_turn(m)
    
    if (step == AIR_STEP_NONE) then
        set_mario_animation(m, MARIO_ANIM_WING_CAP_FLY)
        if m.actionTimer == 3 then
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 8.2, 26, 40, 0, 10, 0, 0, 0, 0, ATTACH_RELATIVE, 4, 1.2)
        end
        
        m.marioObj.header.gfx.angle.z = m.faceAngle.y+m.actionTimer*(13000-(m.actionTimer*420))+0x8000
        if m.actionTimer == 20 then
            set_mario_action(m, ACT_FREEFALL, 0)
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_WALKING, 0)
    end
end

function act_kirby_ground_pound(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    if m.actionTimer > 6 then
        obj_set_model_extended(m.marioObj, E_MODEL_THWOMP)
        m.marioObj.header.gfx.scale.x = 0.25
        m.marioObj.header.gfx.scale.y = 0.25
        m.marioObj.header.gfx.scale.z = 0.25
    end
    if (step == AIR_STEP_NONE) then
        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
        elseif (m.actionState == 1) then
            set_mario_animation(m, MARIO_ANIM_TWIRL)
            m.vel.x = m.vel.x * 0.95
            m.vel.y = m.vel.y * 0.6
            m.vel.z = m.vel.z * 0.95
            e.animFrame = e.animFrame + 1
            
            if e.animFrame >= 12 then
                m.actionState = 2
            end
        elseif (m.actionState == 2) then
            -- Create Hitbox
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.5, 16.4, 40, 30, 0, -50, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.5)
            m.actionState = 3
        elseif (m.actionState == 3) then
            m.vel.x = 0
            m.vel.y = -120
            m.vel.z = 0
            
            m.actionState = 3
        end

        if (m.controller.buttonPressed & A_BUTTON) ~= 0 and e.groundPoundA then
            e.groundPoundA = false
            m.faceAngle.y = m.intendedYaw
            set_mario_action(m, ACT_GROUND_POUND_A, 0)--gCharData[m.character.type].groundPoundA(m)
        end

        if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            set_mario_action(m, ACT_GROUND_POUND_B, 0)--gCharData[m.character.type].groundPoundB(m)
        end

    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_GROUND_POUND_LAND, 0)
        m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
    end
end

function act_kirby_ground_pound_a(m)
    local e = gMarioStateExtras[m.playerIndex]
    set_mario_action(m, ACT_DOUBLE_JUMP, 0)
    m.faceAngle.y = m.intendedYaw
end

function act_kirby_ground_pound_b(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if (step == AIR_STEP_NONE) then
        if m.actionState == 0 then
            m.faceAngle.y = m.intendedYaw
            mario_set_forward_vel(m, 36)
            m.vel.y = 24
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 9.2, 32, 45, 0, 0, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.2)
            m.actionState = 1
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_DIVE)

            if m.marioObj.header.gfx.animInfo.animFrame < m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                e.animFrame = e.animFrame + 1
            end

            mario_set_forward_vel(m, 36)
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x400, 0x400)
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
    end
end

function act_kirby_slide_kick(m)

    local s = gPlayerSyncTable[m.playerIndex]
    local np = gNetworkPlayers[m.playerIndex]
    local charTbl = gCharData[s.character]

    local copyCharIndex = s.copyAbility

    local copyCharTbl = gCharData[copyCharIndex]

    if copyCharIndex ~= charTbl.charId and charTbl.name == "Kirby" then
        copyCharTbl.slideKick(m)
        return
    end
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    local copyMario = nearest_mario_state_to_object(m.marioObj)
    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    m.actionTimer = m.actionTimer + 1
    e.animFrame = e.animFrame + 1
    
    if (step == GROUND_STEP_NONE or step == GROUND_STEP_HIT_WALL) then
        if m.actionState == 0 then
            set_mario_animation(m, MARIO_ANIM_WALK_PANTING)
            create_hitbox(m, E_MODEL_TWEESTER, SOUND_GENERAL_SWISH_AIR, 0.8, 0.0, -16, 295, sins(m.faceAngle.y)*120, 30, coss(m.faceAngle.y)*120, 0, 0, 0, ATTACH_NONE, 1000, 0)
            m.actionState = 1
        elseif m.actionState == 1 then
            mario_set_forward_vel(m, m.forwardVel * 0.6)
            cur_obj_play_sound_2(SOUND_AIR_BLOW_WIND)
            
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x400, 0x400)

            if (dist_between_objects(m.marioObj, copyMario.marioObj) < 150) and m.playerIndex == 0 then
                if gGlobalSyncTable.gameMode ~= GAME_MODE_BOSS or (gNetworkPlayers[copyMario.playerIndex].globalIndex ~= gGlobalSyncTable.bossPlayer and gGlobalSyncTable.gameMode == GAME_MODE_BOSS) then
                    network_send_to(copyMario.playerIndex, true, {eatenBy = np.globalIndex})
                    m.actionState = 3
                end
                --
            end

            if (m.actionTimer > 20 and (m.controller.buttonDown & (B_BUTTON | Z_TRIG)) == 0) then
                e.animFrame = 0
                m.actionState = 2
            end
        elseif m.actionState == 2 then
            set_mario_animation(m, MARIO_ANIM_SLIDEFLIP_LAND)
            e.animFrame = e.animFrame - 0.3
            m.marioObj.header.gfx.angle.y = m.faceAngle.y + 0x8000
            if (m.marioObj.header.gfx.animInfo.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd) then
                set_mario_action(m, ACT_IDLE, 0)
            end
        elseif m.actionState == 3 then
            m.faceAngle.y = m.intendedYaw
            mario_set_forward_vel(m, m.intendedMag*0.2)
            if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                network_send_to(copyMario.playerIndex, true, {eatenBy = -1, spitType = 0})
                set_mario_action(m, ACT_JUMP, 0)
            end
            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                network_send_to(copyMario.playerIndex, true, {eatenBy = -1, spitType = 1})
                s.copyAbility = gPlayerSyncTable[copyMario.playerIndex].character
                set_mario_action(m, ACT_JUMP, 0)
            end
        end
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
    if m.marioObj.header.gfx.animInfo.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
        e.animFrame = 0
    end
end

function on_packet_receive(dataTable)
    local m = gMarioStates[0]
    if dataTable.eatenBy ~= nil then
        if dataTable.eatenBy == -1 then
            local mEaten = nearest_mario_state_to_object(m.marioObj)
            m.pos.x = mEaten.pos.x
            m.pos.y = mEaten.pos.y+100
            m.pos.z = mEaten.pos.z

            calculate_damage(m, 8.6, 48, 20+dataTable.spitType*50, mEaten.faceAngle.y, 1.3)
        else
            set_mario_action(m, ACT_EATEN, dataTable.eatenBy)
        end
    end
    if dataTable.eatCancel ~= nil then
        if dataTable.eatCancel then
            set_mario_action(m, ACT_FREEFALL, 0)
            mario_set_forward_vel(m, -12)
            m.vel.y = 16
        end
    end
end

ACT_EATEN = allocate_mario_action(ACT_FLAG_CUSTOM_ACTION)

hook_event(HOOK_ON_PACKET_RECEIVE, on_packet_receive)

function act_eaten(m)
    local mEatenIndex = network_local_index_from_global(m.actionArg)
    local mEaten = gMarioStates[mEatenIndex]

    m.actionTimer = m.actionTimer + 1
    
    cur_obj_disable_rendering_and_become_intangible(m.marioObj)
    
    targetM = nil

    if (mEaten.action ~= ACT_SLIDE_KICK) then
        --calculate_damage(m, 8.6, 48, 30, mEaten.faceAngle.y, 0.8)
    end

    m.pos.x = mEaten.pos.x
    m.pos.y = mEaten.pos.y+100
    m.pos.z = mEaten.pos.z
    -- After 1.5 seconds + 1/2 of the player's health, exit the action.
    if m.actionTimer > 45+(gPlayerSyncTable[0].hp*0.5) then
        if m.playerIndex == 0 then
            network_send_to(mEaten.playerIndex, true, {eatCancel = true})
            calculate_damage(m, 0, 36, 20, mEaten.faceAngle.y, 0)
        end
    end
end

hook_mario_action(ACT_EATEN, act_eaten, 0)

function act_kirby_dash(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if (step == GROUND_STEP_NONE) then
        if m.actionState == 0 then
            mario_set_forward_vel(m, 64)
            set_mario_animation(m, MARIO_ANIM_DIVE)
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 14, 32, 15, sins(m.faceAngle.y)*150, 50, coss(m.faceAngle.y)*150, 0, 0, 0, ATTACH_RELATIVE, 6, 1.05)
            m.actionState = 1
        elseif m.actionState == 1 then
            e.animFrame = e.animFrame + 1
            mario_set_forward_vel(m, m.forwardVel * 0.75)
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                m.actionTimer = 0
            end
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x200, 0x200)
        elseif m.actionState == 2 then
            set_mario_animation(m, MARIO_ANIM_SLOW_LAND_FROM_DIVE)
            mario_set_forward_vel(m, m.forwardVel * 0.4)
            e.animFrame = e.animFrame + 1
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                set_mario_action(m, ACT_IDLE, 0)
            end
        end
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

palKirby = {
    [1] = {
        [PANTS] = 0x000000,
        [SHIRT] = 0x000000,
        [GLOVES] = 0x000000,
        [SHOES] = 0xFF0044, -- Shoes
        [HAIR] = 0x000000,
        [SKIN] = 0x000000,
        [CAP] = 0xFF6DFF,   -- Body
        [EMBLEM] = 0x000000,
    },
    [2] = {
        [PANTS] = 0x000000,
        [SHIRT] = 0x000000,
        [GLOVES] = 0x000000,
        [SHOES] = 0xFF6500, -- Shoes
        [HAIR] = 0x000000,
        [SKIN] = 0x000000,
        [CAP] = 0xFFEC56,   -- Body
        [EMBLEM] = 0x000000,
    },
    [3] = {
        [PANTS] = 0x000000,
        [SHIRT] = 0x000000,
        [GLOVES] = 0x000000,
        [SHOES] = 0x2355FF, -- Shoes
        [HAIR] = 0x000000,
        [SKIN] = 0x000000,
        [CAP] = 0x59B2FF,   -- Body
        [EMBLEM] = 0x000000,
    },
    [4] = {
        [PANTS] = 0x000000,
        [SHIRT] = 0x000000,
        [GLOVES] = 0x000000,
        [SHOES] = 0xE000BB, -- Shoes
        [HAIR] = 0x000000,
        [SKIN] = 0x000000,
        [CAP] = 0xFF2244,   -- Body
        [EMBLEM] = 0x000000,
    },
    [5] = {
        [PANTS] = 0x000000,
        [SHIRT] = 0x000000,
        [GLOVES] = 0x000000,
        [SHOES] = 0xFFD100, -- Shoes
        [HAIR] = 0x000000,
        [SKIN] = 0x000000,
        [CAP] = 0x33D100,   -- Body
        [EMBLEM] = 0x000000,
    },
    [6] = {
        [PANTS] = 0x000000,
        [SHIRT] = 0x000000,
        [GLOVES] = 0x000000,
        [SHOES] = 0x7F7F7F, -- Shoes
        [HAIR] = 0x000000,
        [SKIN] = 0x000000,
        [CAP] = 0xEFEFEF,   -- Body
        [EMBLEM] = 0x000000,
    },
}

smash_add_character(
    "Kirby",
    1.65,                           -- Weight (How much a part of knockback affects the character)
    1,                              -- Size of hurtbox
    40,                             -- Top Speed
    8,                              -- Acceleration
    4,                              -- Deceleration
    3.5,                            -- Friction
    texMenuCharKirby,
    E_MODEL_KIRBY,                  -- Character Model
    CT_TOAD,                       -- Character Override
    kirby_mario_update,             -- Character Mario Update
    kirby_before_mario_update,      -- Character Before Mario Update
    kirby_stock_render,             -- Character Stock Icon Render
    kirby_on_hud_render,
    -- Actions
    act_kirby_jab,
    act_kirby_aerial,
    act_kirby_ground_pound,
    act_kirby_ground_pound_a,
    act_kirby_ground_pound_b,
    act_kirby_slide_kick,
    act_kirby_dash,
    palKirby
)