-- char-luigi

texStockLuigi = get_texture_info("hud-stock-luigi")
texMenuCharLuigi = get_texture_info("menu-icon-luigi")

function luigi_mario_update(m)

end

function luigi_before_mario_update(m)

end

function luigi_stock_render(x, y, i, palTbl)
    network_player_palette_to_color(gNetworkPlayers[i], PANTS, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockRing, x, y, 1, 1)
    network_player_palette_to_color(gNetworkPlayers[i], CAP, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockLuigi, x, y, 1, 1)
end

function luigi_on_hud_render()

end

function act_luigi_jab(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    
    if (step == GROUND_STEP_NONE) then

        m.vel.x = m.vel.x * 0.8
        m.vel.z = m.vel.z * 0.8

        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
        elseif (m.actionState == 1) then -- Punch 1 Start -- Hitbox
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.6, 1.2, -6, -20, sins(m.faceAngle.y)*100, 75, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 1)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                e.animFrame = 0
            end
        elseif (m.actionState == 2) then -- Punch 1 End
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH_FAST)
            e.animFrame = e.animFrame + 1

            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 3
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 3) then -- Punch 2 Start -- Hitbox --
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.6, 1.2, 6, -20, sins(m.faceAngle.y)*100, 75, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 1)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 4
                e.animFrame = 0
            end
            
        elseif (m.actionState == 4) then -- Punch 2 End
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH_FAST)
            e.animFrame = e.animFrame + 1
            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 5
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 5) then -- Kick End      -- Hitbox --
            set_mario_animation(m, MARIO_ANIM_GROUND_KICK)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.9, 3, 24, 40, sins(m.faceAngle.y)*100, 85, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 1.2)
            end
        end

        if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            set_mario_action(m, ACT_IDLE, 0)
        end

    elseif (step == GROUND_STEP_LEFT_GROUND) then
        set_mario_action(m, ACT_DOUBLE_JUMP, 2)
    end
end

function act_luigi_aerial(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if m.actionTimer == 0 then
        m.vel.y = 16
    end
    m.actionTimer = m.actionTimer + 1
    
    if (step == AIR_STEP_NONE) then
        set_mario_animation(m, MARIO_ANIM_TWIRL)
        if m.actionTimer % 3 == 0 then
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 1.2, m.forwardVel, 20, 0, 50, 0, 0, 0, 0, ATTACH_RELATIVE, 2, 1.1)
        end
        m.vel.y = m.vel.y + 1
        m.marioObj.header.gfx.angle.y = m.faceAngle.y+m.actionTimer*(13000-(m.actionTimer*420))+0x8000
        if m.actionTimer == 20 then
            set_mario_action(m, ACT_FREEFALL, 0)
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_WALKING, 0)
    end
end

function act_luigi_ground_pound(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == AIR_STEP_NONE) then
        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
        elseif (m.actionState == 1) then
            set_mario_animation(m, MARIO_ANIM_START_GROUND_POUND)
            m.vel.x = m.vel.x * 0.7
            m.vel.y = 2
            m.vel.z = m.vel.z * 0.7
            e.animFrame = e.animFrame + (e.animFrame*0.2) + 0.5
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                m.actionTimer = 0
            end
        elseif (m.actionState == 2) then
            -- Create Hitbox
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, 8.6, 32, 280, 0, -50, 0, 0, 0, 0, ATTACH_RELATIVE, 6, 1.5)
            m.actionState = 3
        elseif (m.actionState == 3) then
            m.vel.x = 0
            m.vel.y = -72
            m.vel.z = 0
            -- Create Hitbox
            if m.actionTimer == 2 then
                --create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 2.4, 32, -80, 0, -70, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.2)
            end
            m.actionState = 3
        end

        if (m.controller.buttonPressed & A_BUTTON) ~= 0 and e.groundPoundA then
            e.groundPoundA = false
            set_mario_action(m, ACT_GROUND_POUND_A, 0)--gCharData[m.character.type].groundPoundA(m)
        end

        if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            set_mario_action(m, ACT_GROUND_POUND_B, 0)--gCharData[m.character.type].groundPoundB(m)
        end

    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_GROUND_POUND_LAND, 0)
        m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
    end
end

function act_luigi_ground_pound_a(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    m.actionTimer = m.actionTimer + 1
    if (step == AIR_STEP_NONE or step == AIR_STEP_HIT_WALL) then
        if m.actionState == 0 then
            m.vel.y = 96
            m.actionState = 1
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_TWIRL)
            m.faceAngle.y = m.intendedYaw
            m.vel.x = lerp(m.vel.x, m.intendedMag*sins(m.intendedYaw), 0.1)
            m.vel.z = lerp(m.vel.z, m.intendedMag*coss(m.intendedYaw), 0.1)
            m.marioObj.header.gfx.angle.y = m.faceAngle.y + m.actionTimer*0x1200
            if m.vel.y < -16 and (m.controller.buttonDown & Z_TRIG) == 0 then
                m.vel.y = m.vel.y + 6
            else 
                m.actionTimer = m.actionTimer + 1
            end

            if m.actionTimer % 3 == 0 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 1.2, 12, 20, 0, 50, 0, 0, 0, 0, ATTACH_RELATIVE, 2, 1.1)
            end

        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_TWIRL_LAND, 0)
    end
end

function act_luigi_ground_pound_b(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    --m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    if m.actionTimer == 0 then
        m.vel.y = 8
    end
    m.actionTimer = m.actionTimer + 1
    if (step == AIR_STEP_NONE or step == AIR_STEP_HIT_WALL) then
        if m.actionState == 0 then
            if (m.controller.buttonDown & B_BUTTON) == 0 or m.actionTimer > 60 then
                set_mario_animation(m, MARIO_ANIM_CROUCHING)
                m.marioObj.header.gfx.animInfo.animFrame = 0
                mario_set_forward_vel(m, 48+(m.actionTimer))
                m.vel.x = m.vel.x * 0.9
                m.vel.y = 40
                m.vel.z = m.vel.z * 0.9

                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, m.forwardVel*0.3, m.forwardVel, 15, sins(m.faceAngle.y)*20, 50, coss(m.faceAngle.y)*20, 0, 0, 0, ATTACH_RELATIVE, m.actionTimer*0.5, 0)

                m.actionTimer = 0
                m.actionState = 1
            else
                m.faceAngle.y = m.intendedYaw
                m.vel.x = m.vel.x * 0.9
                if m.vel.y < -32 then
                    m.vel.y = m.vel.y + 4
                else 
                    m.vel.y = m.vel.y + 3
                end
                m.vel.z = m.vel.z * 0.9
            end
        elseif m.actionState == 1 then
            set_mario_anim_with_accel(m, MARIO_ANIM_FLY_FROM_CANNON, 0x800 * m.forwardVel)
            
            mario_set_forward_vel(m, m.forwardVel*0.95)
            m.vel.y = m.vel.y + 3

            if m.forwardVel < 20 then
                set_mario_action(m, ACT_FREEFALL, 0)
            end
        end
    elseif (step == AIR_STEP_LANDED) then
        if m.actionState == 0 then
            if (m.controller.buttonDown & B_BUTTON) == 0 or m.actionTimer > 60 then
                set_mario_animation(m, MARIO_ANIM_CROUCHING)
                m.marioObj.header.gfx.animInfo.animFrame = 0
                mario_set_forward_vel(m, 48+(m.actionTimer))
                m.vel.y = 40

                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, m.forwardVel*0.3, m.forwardVel, 15, sins(m.faceAngle.y)*20, 50, coss(m.faceAngle.y)*20, 0, 0, 0, ATTACH_RELATIVE, m.actionTimer*0.5, 0)

                m.actionTimer = 0
                m.actionState = 1
            else
                m.faceAngle.y = m.intendedYaw
                m.vel.x = m.vel.x * 0.9
                m.vel.z = m.vel.z * 0.9
            end
        else
            set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
        end
    end
end

function act_luigi_slide_kick(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    if (m.actionTimer == 0) then
        
        mario_set_forward_vel(m, 40)
    end
    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == AIR_STEP_NONE) then
        set_mario_animation(m, MARIO_ANIM_SLIDE_KICK)
        e.animFrame = e.animFrame + 1
        if (m.actionTimer % 3 == 0) then
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.6, 2.4, 46, 10, sins(m.faceAngle.y)*140, 50, coss(m.faceAngle.y)*140, 0, 0, 0, ATTACH_RELATIVE, 2, 0)
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
    end
end

function act_luigi_dash(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    m.actionTimer = m.actionTimer + 1
    if (step == GROUND_STEP_NONE or step == GROUND_STEP_HIT_WALL) then
        if m.actionState == 0 then
            mario_set_forward_vel(m, 60)
            set_mario_animation(m, MARIO_ANIM_WALK_WITH_LIGHT_OBJ)
            m.actionState = 1
            
        elseif m.actionState == 1 then
            m.marioObj.header.gfx.angle.y = m.faceAngle.y+sins(m.actionTimer*0x4000)*0x1500---0x2000*m.actionTimer
            m.marioObj.header.gfx.angle.x = 0x1000
            mario_set_forward_vel(m, m.forwardVel * 0.95)
            e.animFrame = e.animFrame + 16
            if m.marioObj.header.gfx.animInfo.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                e.animFrame = e.animFrame - m.marioObj.header.gfx.animInfo.curAnim.loopEnd
            end
            if m.actionTimer % 4 == 0 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, 0.6, m.forwardVel, 30, sins(m.faceAngle.y)*120, 50, coss(m.faceAngle.y)*120, 0, 0, 0, ATTACH_RELATIVE, 2, 0)
            end
            if m.actionTimer > 25 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.2, 8.2, 32, 55, sins(m.faceAngle.y)*150, 50, coss(m.faceAngle.y)*150, 0, 0, 0, ATTACH_RELATIVE, 4, 1.1)
                m.actionState = 2
                e.animFrame = 0
            end
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x200, 0x200)
        elseif m.actionState == 2 then
            set_mario_animation(m, MARIO_ANIM_WALK_PANTING)
            mario_set_forward_vel(m, m.forwardVel * 0.8)
            local animSpeed = 1
            
            e.animFrame = e.animFrame + animSpeed
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                set_mario_action(m, ACT_IDLE, 0)
            end
        end
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

palLuigi = {
    [1] = {
        [PANTS] = 0x0000F0,     -- Head
        [SHIRT] = 0x3DD33F,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x893F3B,     -- ????
        [HAIR] = 0x893F3B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x3DD33F,       -- Spikes???
        [EMBLEM] = 0x3DD33F,
    },
    [2] = {
        [PANTS] = 0x0000F0,     -- Head
        [SHIRT] = 0xDF0022,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x893F3B,     -- ????
        [HAIR] = 0x893F3B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0xDF0022,       -- Spikes???
        [EMBLEM] = 0xDF0022,
    },
    [3] = { -- Waluigi
        [PANTS] = 0x251D44,     -- Head
        [SHIRT] = 0x8352E0,     -- Body/Arms
        [GLOVES] = 0xFFCCFF,    -- ????
        [SHOES] = 0xFF7A46,     -- ????
        [HAIR] = 0x9B713B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x8352E0,       -- Spikes???
        [EMBLEM] = 0xFFC944,
    },
    [4] = { -- :]
        [PANTS] = 0x54CEFF,     -- Head
        [SHIRT] = 0xFF7FF2,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x893F3B,     -- ????
        [HAIR] = 0x893F3B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x54CEFF,       -- Spikes???
        [EMBLEM] = 0x54CEFF,
    },
    [5] = {
        [PANTS] = 0x3DD33F,     -- Head
        [SHIRT] = 0xF5F0FF,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x893F3B,     -- ????
        [HAIR] = 0x893F3B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0xF5F0FF,       -- Spikes???
        [EMBLEM] = 0x3DD33F,
    },
    [6] = {
        [PANTS] = 0x212133,     -- Head
        [SHIRT] = 0x3DD33F,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x3DD33F,     -- ????
        [HAIR] = 0x893F3B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x212133,       -- Spikes???
        [EMBLEM] = 0x3DD33F,
    },
}

smash_add_character(
    "Luigi",
    1.1,                        -- Weight (How much a part of knockback affects the character)
    0.9,                        -- Size of hurtbox
    40,                         -- Top Speed
    4,                          -- Acceleration
    2,                          -- Deceleration
    1.5,                        -- Friction
    texMenuCharLuigi,
    E_MODEL_LUIGI,              -- Character Model
    CT_LUIGI,                   -- Character Override
    luigi_mario_update,         -- Character Mario Update
    luigi_before_mario_update,  -- Character Before Mario Update
    luigi_stock_render,         -- Character Stock Icon Render
    luigi_on_hud_render,
    -- Actions
    act_luigi_jab,
    act_luigi_aerial,
    act_luigi_ground_pound,
    act_luigi_ground_pound_a,
    act_luigi_ground_pound_b,
    act_luigi_slide_kick,
    act_luigi_dash,
    palLuigi
)