-- char-sonic

E_MODEL_SONIC = smlua_model_util_get_id("sonic_geo")

texStockSonic = get_texture_info("hud-stock-sonic")
texStockSonicBack = get_texture_info("hud-stock-sonic-back")
texMenuCharSonic = get_texture_info("menu-icon-sonic")

function sonic_mario_update(m)

end

function sonic_before_mario_update(m)

end

function sonic_stock_render(x, y, i, palTbl)
    
    djui_hud_set_color(255, 255, 255, 255)
    djui_hud_render_texture(texStockSonicBack, x, y, 1, 1)
    network_player_palette_to_color(gNetworkPlayers[i], PANTS, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockSonic, x, y, 1, 1)
end

function sonic_on_hud_render()

end

function act_sonic_jab(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    
    if (step == GROUND_STEP_NONE) then

        m.vel.x = m.vel.x * 0.8
        m.vel.z = m.vel.z * 0.8

        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
            m.faceAngle.y = m.intendedYaw
        elseif (m.actionState == 1) then -- Punch 1 Start -- Hitbox
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH)
            
            if e.animFrame < 2 then
                m.faceAngle.y = m.intendedYaw
            end
            
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.6, 1.2, -6, -20, sins(m.faceAngle.y)*100, 75, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 0.2)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                e.animFrame = 0
            end
        elseif (m.actionState == 2) then -- Punch 1 End
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH_FAST)
            e.animFrame = e.animFrame + 1

            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 3
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 3) then -- Punch 2 Start -- Hitbox --
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.6, 1.2, 6, -20, sins(m.faceAngle.y)*100, 75, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 0.2)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 4
                e.animFrame = 0
            end
            
        elseif (m.actionState == 4) then -- Punch 2 End
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH_FAST)
            e.animFrame = e.animFrame + 1
            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 5
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 5) then -- Kick End      -- Hitbox --
            set_mario_animation(m, MARIO_ANIM_GROUND_KICK)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.9, 3, 28, 20, sins(m.faceAngle.y)*100, 85, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 1.3)
            end
        end

        if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            set_mario_action(m, ACT_IDLE, 0)
        end

    elseif (step == GROUND_STEP_LEFT_GROUND) then
        set_mario_action(m, ACT_DOUBLE_JUMP, 2)
    end
end

function act_sonic_aerial(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    m.vel.y = m.vel.y + 1

    update_air_without_turn(m)

    if (step == AIR_STEP_NONE) then
        if (m.actionState == 0) then
            e.animFrame = 0
            m.vel.y = m.vel.y * 0.5
            m.actionState = 1
        elseif (m.actionState == 1) then
            e.animFrame = e.animFrame + 2.3
            
            if m.actionTimer >= 4 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_METAL_LANDING, 0.9, 9.6, 36, 280, sins(m.faceAngle.y)*140, 100, coss(m.faceAngle.y)*140, 0, 0, 0, ATTACH_RELATIVE, 6, 1.4)
                m.actionState = 2
            else
                set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)
            end
            local sidewaysSpeed = m.intendedMag * sins(m.intendedYaw-m.faceAngle.y) * 0.1
            local forwardSpeed = m.intendedMag * coss(m.intendedYaw-m.faceAngle.y) * 0.1
            
            --[[m.vel.x = m.vel.x * 0.9
            m.vel.z = m.vel.z * 0.9
            m.vel.x = m.vel.x + (sidewaysSpeed * sins(m.faceAngle.y + 0x4000)) + (forwardSpeed * sins(m.faceAngle.y))
            m.vel.z = m.vel.z + (sidewaysSpeed * coss(m.faceAngle.y + 0x4000)) + (forwardSpeed * coss(m.faceAngle.y))]]
        elseif (m.actionState == 2) then
            -- Create Hitbox
            set_mario_animation(m, MARIO_ANIM_AIR_KICK)
            e.animFrame = 10
        end
        --m.slideVelX = m.vel.x
        --m.slideVelZ = m.vel.z
        if m.actionTimer >= 11 then
            set_mario_action(m, ACT_FREEFALL, 0)
        end
    elseif (step == AIR_STEP_LANDED) then
        m.faceAngle.y = m.intendedYaw
        return set_mario_action(m, ACT_STOMACH_SLIDE_STOP, 0)
    end
end

function act_sonic_ground_pound(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == AIR_STEP_NONE) then
        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
            m.vel.y = 2
        elseif (m.actionState == 1) then
            set_mario_animation(m, MARIO_ANIM_START_CROUCHING)
            m.vel.x = m.vel.x * 0.7
            m.vel.y = 4
            m.vel.z = m.vel.z * 0.7
            e.animFrame = e.animFrame + (e.animFrame*0.2) + 0.5
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                m.actionTimer = 0
            end
        elseif (m.actionState == 2) then
            set_mario_animation(m, MARIO_ANIM_GENERAL_FALL)
            -- Create Hitbox
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, 8.6, 32, 280, 0, -50, 0, 0, 0, 0, ATTACH_RELATIVE, 6, 1.5)
            m.actionState = 3
        elseif (m.actionState == 3) then
            m.vel.x = 0
            m.vel.y = -96
            m.vel.z = 0
            -- Create Hitbox
            if m.actionTimer == 2 then
                --create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 2.4, 32, -80, 0, -70, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.2)
            end
            m.actionState = 3
        end

        if (m.controller.buttonPressed & A_BUTTON) ~= 0 and e.groundPoundA then
            e.groundPoundA = false
            set_mario_action(m, ACT_GROUND_POUND_A, 0)--gCharData[m.character.type].groundPoundA(m)
        end

        if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            set_mario_action(m, ACT_GROUND_POUND_B, 0)--gCharData[m.character.type].groundPoundB(m)
        end

    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_GROUND_POUND_LAND, 0)
        m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
    end
end

function act_sonic_ground_pound_a(m)
    set_mario_action(m, ACT_DOUBLE_JUMP, 0)
    
    m.vel.y = 96
end

function act_sonic_ground_pound_b(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if (step == AIR_STEP_NONE) then
        if m.actionState == 0 then
            m.faceAngle.y = m.intendedYaw
            mario_set_forward_vel(m, 36)
            m.vel.y = 24
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 12.6, 24, 15, 0, 0, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.3)
            m.actionState = 1
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_SLIDE_KICK)

            if m.marioObj.header.gfx.animInfo.animFrame < m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                e.animFrame = e.animFrame + 1
            end

            mario_set_forward_vel(m, 48)
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x400, 0x400)
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
    elseif (step == AIR_STEP_HIT_WALL) then
        m.vel.y = 36
        mario_set_forward_vel(m, -32)
        set_mario_action(m, ACT_TOP_OF_POLE_JUMP, 0)
    end
end

function act_sonic_slide_kick(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    if (m.actionTimer == 0) then
        mario_set_forward_vel(m, max(m.forwardVel, 60))
    end
    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == GROUND_STEP_NONE) then
        mario_set_forward_vel(m, m.forwardVel - 1)
        m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x400, 0x400)
        set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)
        e.animFrame = e.animFrame + 2
        if (m.actionTimer % 2 == 0) then
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.6, 1.2, m.forwardVel+12, 15, sins(m.faceAngle.y)*140, 50, coss(m.faceAngle.y)*140, 0, 0, 0, ATTACH_RELATIVE, 2, 0)
        end

        if e.animFrame > m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            e.animFrame = e.animFrame - m.marioObj.header.gfx.animInfo.curAnim.loopEnd
        end
        if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
            set_mario_action(m, ACT_JUMP, 0)
        end
        if m.forwardVel < 24 or (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            set_mario_action(m, ACT_WALKING, 0)
        end
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

function act_sonic_dash(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if (step == GROUND_STEP_NONE) then
        if m.actionState == 0 then
            mario_set_forward_vel(m, 80)
            set_mario_animation(m, MARIO_ANIM_BREAKDANCE)
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 8, 40, 35, sins(m.faceAngle.y)*150, 50, coss(m.faceAngle.y)*150, 0, 0, 0, ATTACH_RELATIVE, 8, 1.05)
            m.actionState = 1
        elseif m.actionState == 1 then
            e.animFrame = e.animFrame + 1
            mario_set_forward_vel(m, m.forwardVel * 0.9)
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                m.actionTimer = 0
            end
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x200, 0x200)
        elseif m.actionState == 2 then
            set_mario_animation(m, MARIO_ANIM_STOP_CROUCHING)
            mario_set_forward_vel(m, m.forwardVel * 0.8)
            e.animFrame = e.animFrame + 1
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                set_mario_action(m, ACT_WALKING, 0)
            end
        end
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

palSonic = {
    [1] = {
        [PANTS] = 0x2E23FF,     -- Head
        [SHIRT] = 0x000000,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0xDF0022,     -- ????
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
    [2] = {
        [PANTS] = 0x2EB6FF,     -- Head
        [SHIRT] = 0x000000,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0xFF2D99,     -- ????
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
    [3] = {
        [PANTS] = 0x212133,     -- Head
        [SHIRT] = 0x000000,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0xF5F0FF,     -- ????
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFB48C,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
    [4] = {
        [PANTS] = 0xDDD0EE,     -- Head
        [SHIRT] = 0x000000,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x212133,     -- ????
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
    [5] = {
        [PANTS] = 0xB775FF,     -- Head
        [SHIRT] = 0x000000,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0xD3377D,     -- ????
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
    [6] = {
        [PANTS] = 0xDF0022,     -- Head
        [SHIRT] = 0x000000,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x00DF22,     -- ????
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x000000,       -- Spikes???
        [EMBLEM] = 0x000000,
    },
    
}

smash_add_character(
    "Sonic",
    1,                          -- Weight (How much a part of knockback affects the character)
    0.9,                        -- Size of hurtbox
    84,                         -- Top Speed
    2,                          -- Acceleration
    4,                          -- Deceleration
    10,                         -- Friction
    texMenuCharSonic,
    E_MODEL_SONIC,              -- Character Model
    CT_MARIO,                   -- Character Override
    sonic_mario_update,         -- Character Mario Update
    sonic_before_mario_update,  -- Character Before Mario Update
    sonic_stock_render,         -- Character Stock Icon Render
    sonic_on_hud_render,
    -- Actions
    act_sonic_jab,
    act_sonic_aerial,
    act_sonic_ground_pound,
    act_sonic_ground_pound_a,
    act_sonic_ground_pound_b,
    act_sonic_slide_kick,
    act_sonic_dash,
    palSonic
)