-- char-toad

texStockToadSpots = get_texture_info("hud-stock-toad-spots")
texMenuCharToad = get_texture_info("menu-icon-toad")

function toad_mario_update(m)

end

function toad_before_mario_update(m)

end

function toad_stock_render(x, y, i, palTbl)
    network_player_palette_to_color(gNetworkPlayers[i], GLOVES, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockToadBase, x, y, 1, 1)
    network_player_palette_to_color(gNetworkPlayers[i], CAP, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockToadSpots, x, y, 1, 1)
end

function toad_on_hud_render()

end

function act_toad_jab(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    
    if (step == GROUND_STEP_NONE) then

        m.vel.x = m.vel.x * 0.8
        m.vel.z = m.vel.z * 0.8

        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
            m.faceAngle.y = m.intendedYaw
        elseif (m.actionState == 1) then -- Punch 1 Start -- Hitbox
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH)
            
            if e.animFrame < 2 then
                m.faceAngle.y = m.intendedYaw
            end
            
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.6, 1.2, -6, -20, sins(m.faceAngle.y)*100, 75, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 0.2)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                e.animFrame = 0
            end
        elseif (m.actionState == 2) then -- Punch 1 End
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH_FAST)
            e.animFrame = e.animFrame + 1

            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 3
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 3) then -- Punch 2 Start -- Hitbox --
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.6, 1.2, 6, -20, sins(m.faceAngle.y)*100, 75, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 0.2)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 4
                e.animFrame = 0
            end
            
        elseif (m.actionState == 4) then -- Punch 2 End
            set_mario_animation(m, MARIO_ANIM_SECOND_PUNCH_FAST)
            e.animFrame = e.animFrame + 1
            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 5
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 5) then -- Kick End      -- Hitbox --
            set_mario_animation(m, MARIO_ANIM_GROUND_KICK)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.9, 3, 28, 20, sins(m.faceAngle.y)*100, 85, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 1.3)
            end
        end

        if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            set_mario_action(m, ACT_IDLE, 0)
        end

    elseif (step == GROUND_STEP_LEFT_GROUND) then
        set_mario_action(m, ACT_DOUBLE_JUMP, 2)
    end
end

function act_toad_aerial(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if (step == AIR_STEP_NONE) then
        if (m.actionState == 0) then
            e.animFrame = 0
            m.vel.y = 16
            m.vel.x = m.vel.x * 0.8
            m.vel.z = m.vel.z * 0.8
            m.actionState = 1
        elseif (m.actionState == 1) then
            e.animFrame = e.animFrame + 1
            set_mario_animation(m, MARIO_ANIM_AIR_KICK)
            local sidewaysSpeed = m.intendedMag * sins(m.intendedYaw-m.faceAngle.y) * 0.1
            local forwardSpeed = m.intendedMag * coss(m.intendedYaw-m.faceAngle.y) * 0.1
            
            m.vel.x = m.vel.x * 0.9
            m.vel.z = m.vel.z * 0.9
            m.vel.x = m.vel.x + (sidewaysSpeed * sins(m.faceAngle.y + 0x4000)) + (forwardSpeed * sins(m.faceAngle.y))
            m.vel.z = m.vel.z + (sidewaysSpeed * coss(m.faceAngle.y + 0x4000)) + (forwardSpeed * coss(m.faceAngle.y))

            -- Create Hitbox
            if e.animFrame == 4 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 6.2, 16, 20, sins(m.faceAngle.y)*140, 100, coss(m.faceAngle.y)*140, 0, 0, 0, ATTACH_RELATIVE, 5, 1.4)
            end
        end
        m.slideVelX = m.vel.x
        m.slideVelZ = m.vel.z
        if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            set_mario_action(m, ACT_FREEFALL, 0)
        end
    elseif (step == AIR_STEP_LANDED) then
        m.faceAngle.y = m.intendedYaw
        return set_mario_action(m, ACT_JUMP_LAND, 0)
    end
end

function act_toad_ground_pound(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == AIR_STEP_NONE) then
        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
            m.vel.y = 2
        elseif (m.actionState == 1) then
            set_mario_animation(m, MARIO_ANIM_START_GROUND_POUND)
            m.vel.x = m.vel.x * 0.7
            m.vel.y = 2
            m.vel.z = m.vel.z * 0.7
            e.animFrame = e.animFrame + (e.animFrame*0.2) + 0.5
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                m.actionTimer = 0
            end
        elseif (m.actionState == 2) then
            -- Create Hitbox
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, 8.6, 32, 280, 0, -50, 0, 0, 0, 0, ATTACH_RELATIVE, 6, 1.5)
            m.actionState = 3
        elseif (m.actionState == 3) then
            m.vel.x = 0
            m.vel.y = -72
            m.vel.z = 0
            -- Create Hitbox
            if m.actionTimer == 2 then
                --create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 2.4, 32, -80, 0, -70, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.2)
            end
            m.actionState = 3
        end

        if (m.controller.buttonPressed & A_BUTTON) ~= 0 and e.groundPoundA then
            e.groundPoundA = false
            set_mario_action(m, ACT_GROUND_POUND_A, 0)--gCharData[m.character.type].groundPoundA(m)
        end

        if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            set_mario_action(m, ACT_GROUND_POUND_B, 0)--gCharData[m.character.type].groundPoundB(m)
        end

    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_GROUND_POUND_LAND, 0)
        m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
    end
end

function act_toad_ground_pound_a(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    --m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    if m.actionTimer == 0 and m.actionState == 0 then
        m.vel.y = 16
    end
    m.actionTimer = m.actionTimer + 1
    if (step == AIR_STEP_NONE) then
        if m.actionState == 0 then
            if (m.controller.buttonDown & A_BUTTON) == 0 or m.actionTimer > 40 then
                set_mario_animation(m, MARIO_ANIM_CROUCHING)
                m.marioObj.header.gfx.animInfo.animFrame = 0
                m.faceAngle.y = m.intendedYaw
                mario_set_forward_vel(m, m.intendedMag)
                m.vel.y = 24+(m.actionTimer*2)

                --create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, m.forwardVel*0.3, m.forwardVel, 15, sins(m.faceAngle.y)*20, 50, coss(m.faceAngle.y)*20, 0, 0, 0, ATTACH_RELATIVE, m.actionTimer*0.5, 0)

                m.actionTimer = 0
                m.actionState = 1
            else
                m.faceAngle.y = m.intendedYaw
                m.vel.x = m.vel.x * 0.9
                if m.vel.y < -32 then
                    m.vel.y = m.vel.y + 4
                else 
                    m.vel.y = m.vel.y + 3
                end
                m.vel.z = m.vel.z * 0.9
            end
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_TRIPLE_JUMP_FLY)
            
            --mario_set_forward_vel(m, m.forwardVel*0.95)
            --m.vel.y = m.vel.y + 3

            if m.vel.y <= -16 then
                set_mario_action(m, ACT_FREEFALL, 0)
            end
        end
    elseif (step == AIR_STEP_LANDED) then
        if m.actionState == 0 then
            if (m.controller.buttonDown & B_BUTTON) == 0 or m.actionTimer > 60 then
                set_mario_animation(m, MARIO_ANIM_CROUCHING)
                m.marioObj.header.gfx.animInfo.animFrame = 0
                mario_set_forward_vel(m, 48+(m.actionTimer))
                m.vel.y = 40

                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, m.forwardVel*0.3, m.forwardVel, 15, sins(m.faceAngle.y)*20, 50, coss(m.faceAngle.y)*20, 0, 0, 0, ATTACH_RELATIVE, m.actionTimer*0.5, 0)

                m.actionTimer = 0
                m.actionState = 1
            else
                m.faceAngle.y = m.intendedYaw
                m.vel.x = m.vel.x * 0.9
                m.vel.z = m.vel.z * 0.9
            end
        else
            set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
        end
    end
end

function act_toad_ground_pound_b(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    --m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    m.actionTimer = m.actionTimer + 1
    if (step == AIR_STEP_NONE) then
        if m.actionState == 0 then
            m.faceAngle.y = m.intendedYaw
            mario_set_forward_vel(m, -8)
            set_mario_animation(m, MARIO_ANIM_TRIPLE_JUMP)
            m.vel.y = 8
            if m.actionTimer > 4 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 14.2, 40, 315, 0, 0, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.2)
                m.actionState = 1
            end
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)
            if m.actionTimer % 4 == 0 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 2.4, 32, 345, 0, 0, 0, 0, 0, 0, ATTACH_RELATIVE, 2, 1.2)
            end
            if m.marioObj.header.gfx.animInfo.animFrame < m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                e.animFrame = e.animFrame + 1
            end
            m.vel.y = -58
            mario_set_forward_vel(m, 68)
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x400, 0x400)
        end
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
    end
end

function act_toad_slide_kick(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    if (m.actionTimer == 0) then
        
        mario_set_forward_vel(m, 40)
    end
    --m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == AIR_STEP_NONE) then
        set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)
        create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 1.2, 46, 10, sins(m.faceAngle.y)*140, 50, coss(m.faceAngle.y)*140, 0, 0, 0, ATTACH_RELATIVE, 2, 0)
        --e.animFrame = e.animFrame + 1
    elseif (step == AIR_STEP_LANDED) then
        create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 4.8, 56, 20, sins(m.faceAngle.y)*140, 50, coss(m.faceAngle.y)*140, 0, 0, 0, ATTACH_RELATIVE, 2, 0)
        set_mario_action(m, ACT_TRIPLE_JUMP_LAND, 0)
    end
end

function act_toad_dash(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if (step == GROUND_STEP_NONE) then
        if m.actionState == 0 then
            mario_set_forward_vel(m, 80)
            set_mario_animation(m, MARIO_ANIM_SLIDE_KICK)
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 12, 32, 15, sins(m.faceAngle.y)*150, 50, coss(m.faceAngle.y)*150, 0, 0, 0, ATTACH_RELATIVE, 6, 1.05)
            m.actionState = 1
        elseif m.actionState == 1 then
            e.animFrame = e.animFrame + 1
            mario_set_forward_vel(m, m.forwardVel * 0.9)
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                m.actionTimer = 0
            end
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x200, 0x200)
        elseif m.actionState == 2 then
            set_mario_animation(m, MARIO_ANIM_GROUND_BONK)
            mario_set_forward_vel(m, m.forwardVel * 0.7)
            e.animFrame = e.animFrame + 1
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                set_mario_action(m, ACT_IDLE, 0)
            end
        end
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

palToad = {
    [1] = {
        [PANTS] = 0xFFFFFF,     -- Pants
        [SHIRT] = 0x5040EF,     -- Overcoat
        [GLOVES] = 0xF5F0FF,    -- Cap
        [SHOES] = 0x893F3B,     -- Shoes
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0xDF0022,       -- Spots
        [EMBLEM] = 0x000000,    -- Nothing?
    },
    [2] = {
        [PANTS] = 0xFFFFFF,     -- Pants
        [SHIRT] = 0x2000EF,     -- Overcoat
        [GLOVES] = 0xF5F0FF,    -- Cap
        [SHOES] = 0x893F3B,     -- Shoes
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x2000EF,       -- Spots
        [EMBLEM] = 0x000000,    -- Nothing?
    },
    [3] = {
        [PANTS] = 0xFFFFFF,     -- Pants
        [SHIRT] = 0xFFD32A,     -- Overcoat
        [GLOVES] = 0xF5F0FF,    -- Cap
        [SHOES] = 0x893F3B,     -- Shoes
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0xFFD32A,       -- Spots
        [EMBLEM] = 0x000000,    -- Nothing?
    },
    [4] = {
        [PANTS] = 0xFFFFFF,     -- Pants
        [SHIRT] = 0xFF7FF2,     -- Overcoat
        [GLOVES] = 0x54CEFF,    -- Cap
        [SHOES] = 0xFF7FF2,     -- Shoes
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0xFF7FF2,       -- Spots
        [EMBLEM] = 0x000000,    -- Nothing?
    },
    [5] = {
        [PANTS] = 0xFFFFFF,     -- Pants
        [SHIRT] = 0x6030EF,     -- Overcoat
        [GLOVES] = 0xF5F0FF,    -- Cap
        [SHOES] = 0x893F3B,     -- Shoes
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x6030EF,       -- Spots
        [EMBLEM] = 0x000000,    -- Nothing?
    },
    [6] = {
        [PANTS] = 0xDF0022,     -- Pants
        [SHIRT] = 0xF5F0FF,     -- Overcoat
        [GLOVES] = 0xDF0022,    -- Cap
        [SHOES] = 0x893F3B,     -- Shoes
        [HAIR] = 0x000000,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0xF5F0FF,       -- Spots
        [EMBLEM] = 0x000000,    -- Nothing?
    },
    
}

smash_add_character(
    "Toad",
    1.5,                        -- Weight (How much a part of knockback affects the character)
    0.6,                        -- Size of hurtbox
    64,                         -- Top Speed
    2,                          -- Acceleration
    3,                          -- Deceleration
    4,                          -- Friction
    texMenuCharToad,
    E_MODEL_TOAD_PLAYER,        -- Character Model
    CT_TOAD,                   -- Character Override
    toad_mario_update,          -- Character Mario Update
    toad_before_mario_update,   -- Character Before Mario Update
    toad_stock_render,          -- Character Stock Icon Render
    toad_on_hud_render,
    -- Actions
    act_toad_jab,
    act_toad_aerial,
    act_toad_ground_pound,
    act_toad_ground_pound_a,
    act_toad_ground_pound_b,
    act_toad_slide_kick,
    act_toad_dash,
    palToad
)