-- char-waluigi

texStockWaluigi = get_texture_info("hud-stock-waluigi")
texMenuCharWaluigi = get_texture_info("menu-icon-waluigi")

function waluigi_mario_update(m)

end

function waluigi_before_mario_update(m)

end

function waluigi_stock_render(x, y, i, palTbl)
    network_player_palette_to_color(gNetworkPlayers[i], PANTS, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockRing, x, y, 1, 1)
    network_player_palette_to_color(gNetworkPlayers[i], CAP, palTbl)
    djui_hud_set_color(palTbl.r, palTbl.g, palTbl.b, 255)
    djui_hud_render_texture(texStockWaluigi, x, y, 1, 1)
end

function waluigi_on_hud_render()

end

function act_waluigi_jab(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    
    if (step == GROUND_STEP_NONE) then

        m.vel.x = m.vel.x * 0.8
        m.vel.z = m.vel.z * 0.8

        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
        elseif (m.actionState == 1) then -- Punch 1 Start -- Hitbox
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.6, 1.2, 24, 80, sins(m.faceAngle.y)*100, 75, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 3, 0.4)
            end

            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                e.animFrame = 0
            end
        elseif (m.actionState == 2) then -- Punch 1 End
            set_mario_animation(m, MARIO_ANIM_FIRST_PUNCH_FAST)
            e.animFrame = e.animFrame + 1

            -- Continue Attack
            if e.animFrame > 0 then
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    m.actionState = 3
                    e.animFrame = 0
                end
            end
        elseif (m.actionState == 3) then -- Kick End      -- Hitbox --
            set_mario_animation(m, MARIO_ANIM_GROUND_KICK)
            e.animFrame = e.animFrame + 1

            -- Create Hitbox
            if e.animFrame == 2 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.9, 3, 30, 20, sins(m.faceAngle.y)*100, 85, coss(m.faceAngle.y)*100, 0, 0, 0, ATTACH_NONE, 5, 1.4)
            end
        end

        if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            set_mario_action(m, ACT_IDLE, 0)
        end

    elseif (step == GROUND_STEP_LEFT_GROUND) then
        set_mario_action(m, ACT_DOUBLE_JUMP, 2)
    end
end

function act_waluigi_aerial(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    if (step == AIR_STEP_NONE) then
        if (m.actionState == 0) then
            e.animFrame = 0
            m.vel.y = 16
            m.vel.x = m.vel.x * 0.8
            m.vel.z = m.vel.z * 0.8
            m.actionState = 1
        elseif (m.actionState == 1) then
            e.animFrame = e.animFrame + 1
            set_mario_animation(m, MARIO_ANIM_AIR_KICK)
            local sidewaysSpeed = m.intendedMag * sins(m.intendedYaw-m.faceAngle.y) * 0.1
            local forwardSpeed = m.intendedMag * coss(m.intendedYaw-m.faceAngle.y) * 0.1
            
            m.vel.x = m.vel.x * 0.9
            m.vel.z = m.vel.z * 0.9
            m.vel.x = m.vel.x + (sidewaysSpeed * sins(m.faceAngle.y + 0x4000)) + (forwardSpeed * sins(m.faceAngle.y))
            m.vel.z = m.vel.z + (sidewaysSpeed * coss(m.faceAngle.y + 0x4000)) + (forwardSpeed * coss(m.faceAngle.y))

            -- Create Hitbox
            if e.animFrame == 4 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.2, 4.4, 16, 20, sins(m.faceAngle.y)*120, 100, coss(m.faceAngle.y)*120, 0, 0, 0, ATTACH_RELATIVE, 7, 1.4)
            end
        end
        m.slideVelX = m.vel.x
        m.slideVelZ = m.vel.z
        if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            set_mario_action(m, ACT_FREEFALL, 0)
        end
    elseif (step == AIR_STEP_LANDED) then
        m.faceAngle.y = m.intendedYaw
        return set_mario_action(m, ACT_JUMP_LAND, 0)
    end
end

function act_waluigi_ground_pound(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == AIR_STEP_NONE) then
        if (m.actionState == 0) then
            e.animFrame = 0
            m.actionState = 1
        elseif (m.actionState == 1) then
            set_mario_animation(m, MARIO_ANIM_START_GROUND_POUND)
            m.vel.x = m.vel.x * 0.7
            m.vel.y = 2
            m.vel.z = m.vel.z * 0.7
            e.animFrame = e.animFrame + (e.animFrame*0.2) + 0.5
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                m.actionState = 2
                m.actionTimer = 0
            end
        elseif (m.actionState == 2) then
            -- Create Hitbox
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, 8.6, 32, 280, 0, -50, 0, 0, 0, 0, ATTACH_RELATIVE, 6, 1.5)
            m.actionState = 3
        elseif (m.actionState == 3) then
            m.vel.x = 0
            m.vel.y = -72
            m.vel.z = 0
            -- Create Hitbox
            if m.actionTimer == 2 then
                --create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 0.8, 2.4, 32, -80, 0, -70, 0, 0, 0, 0, ATTACH_RELATIVE, 12, 1.2)
            end
            m.actionState = 3
        end

        if (m.controller.buttonPressed & A_BUTTON) ~= 0 and e.groundPoundA then
            e.groundPoundA = false
            set_mario_action(m, ACT_GROUND_POUND_A, 0)--gCharData[m.character.type].groundPoundA(m)
        end

        if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            set_mario_action(m, ACT_GROUND_POUND_B, 0)--gCharData[m.character.type].groundPoundB(m)
        end

    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_GROUND_POUND_LAND, 0)
        m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
    end
end

function act_waluigi_ground_pound_a(m)
    local e = gMarioStateExtras[m.playerIndex]
    set_mario_action(m, ACT_DOUBLE_JUMP, 0)
    m.faceAngle.y = m.intendedYaw
end

function act_waluigi_ground_pound_b(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    local e = gMarioStateExtras[m.playerIndex]

    --m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    m.actionTimer = m.actionTimer + 1
    if (step == AIR_STEP_NONE) then
        if m.actionState == 0 then
            m.faceAngle.y = m.intendedYaw
            mario_set_forward_vel(m, 50)
            m.vel.y = 0
            m.actionState = 1
        elseif m.actionState == 1 then
            set_mario_anim_with_accel(m, MARIO_ANIM_FLUTTERKICK, 0x800 * m.forwardVel)
            m.vel.y = m.vel.y + 3.5
            if m.actionTimer % 3 == 0 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.1, 1.2, m.forwardVel, 15, sins(m.faceAngle.y)*20, 50, coss(m.faceAngle.y)*20, 0, 0, 0, ATTACH_RELATIVE, 2, 0)
            end
            mario_set_forward_vel(m, m.forwardVel*0.95)
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x800, 0x800)

            if m.forwardVel < 8 then
                set_mario_action(m, ACT_FREEFALL, 0)
            end
        end
    elseif (step == AIR_STEP_HIT_WALL) then
        m.faceAngle.y = atan2s(m.wallNormal.z, m.wallNormal.x)+0x8000
        mario_set_forward_vel(m, -48)
        m.vel.y = 32
        set_mario_action(m, ACT_FREEFALL, 0)
    elseif (step == AIR_STEP_LANDED) then
        set_mario_action(m, ACT_FORWARD_ROLLOUT, 0)
    end
end

function act_waluigi_slide_kick(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    if (m.actionTimer == 0) then
        --mario_set_forward_vel(m, 20)
    end
    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame

    m.actionTimer = m.actionTimer + 1
    
    if (step == GROUND_STEP_NONE) then
        set_mario_animation(m, MARIO_ANIM_BREAKDANCE)
        e.animFrame = e.animFrame + 1.5
        if (m.actionTimer == 4) then
            create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1, 7.8, 42, 60, sins(m.faceAngle.y)*50, 50, coss(m.faceAngle.y)*50, 0, 0, 0, ATTACH_RELATIVE, 2, 0.1)
        end
        if e.animFrame >= 10 and (m.controller.buttonPressed & A_BUTTON) ~= 0 then
            set_mario_action(m, ACT_JUMP, 0)
        end
        if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
            set_mario_action(m, ACT_IDLE, 0)
        end
        mario_set_forward_vel(m, m.forwardVel * 0.9)
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

function act_waluigi_dash(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    m.marioObj.header.gfx.animInfo.animFrame = e.animFrame
    m.actionTimer = m.actionTimer + 1
    if (step == GROUND_STEP_NONE) then
        if m.actionState == 0 then
            mario_set_forward_vel(m, 70)
            set_mario_animation(m, MARIO_ANIM_TWIRL)
            m.actionState = 1
            
        elseif m.actionState == 1 then
            m.marioObj.header.gfx.angle.y = -0x2000*m.actionTimer
            mario_set_forward_vel(m, m.forwardVel * 0.95)
            
            if m.actionTimer % 3 == 0 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.3, 1.2, m.forwardVel, 15, sins(m.faceAngle.y)*120, 50, coss(m.faceAngle.y)*120, 0, 0, 0, ATTACH_RELATIVE, 2, 0)
            end
            if m.actionTimer > 20 then
                create_hitbox(m, E_MODEL_NONE, SOUND_ACTION_BONK, 1.4, 9.6, 32, 20, sins(m.faceAngle.y)*150, 50, coss(m.faceAngle.y)*150, 0, 0, 0, ATTACH_RELATIVE, 4, 1.1)
                m.actionState = 2
                e.animFrame = 15
            end
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x200, 0x200)
        elseif m.actionState == 2 then
            set_mario_animation(m, MARIO_ANIM_STAR_DANCE)
            mario_set_forward_vel(m, m.forwardVel * 0.7)
            local animSpeed = 1
            if e.animFrame < 36 then
                animSpeed = 3
            end
            e.animFrame = e.animFrame + animSpeed
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                set_mario_action(m, ACT_IDLE, 0)
            end
        end
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

palWaluigi = {
    [1] = { -- Waluigi
        [PANTS] = 0x251D44,     -- Head
        [SHIRT] = 0x8352E0,     -- Body/Arms
        [GLOVES] = 0xFFCCFF,    -- ????
        [SHOES] = 0xFF7A46,     -- ????
        [HAIR] = 0x9B713B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x8352E0,       -- Spikes???
        [EMBLEM] = 0xFFC944,
    },
    [2] = { -- Wario
        [PANTS] = 0xB633DC,     -- Head
        [SHIRT] = 0xFFD946,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x3DA33F,     -- ????
        [HAIR] = 0x9B713B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0xFFD946,       -- Spikes???
        [EMBLEM] = 0x0000FF,
    },
    [3] = {
        [PANTS] = 0x0000F0,     -- Head
        [SHIRT] = 0x3DD33F,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x893F3B,     -- ????
        [HAIR] = 0x893F3B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x3DD33F,       -- Spikes???
        [EMBLEM] = 0x3DD33F,
    },
    [4] = { -- :]
        [PANTS] = 0x54CEFF,     -- Head
        [SHIRT] = 0xFF7FF2,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x893F3B,     -- ????
        [HAIR] = 0x893F3B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x54CEFF,       -- Spikes???
        [EMBLEM] = 0x54CEFF,
    },
    [5] = { -- what the shit
        [PANTS] = 0x3DD33F,     -- Head
        [SHIRT] = 0x54CEFF,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x893F3B,     -- ????
        [HAIR] = 0x893F3B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x54CEFF,       -- Spikes???
        [EMBLEM] = 0xFFC944,
    },
    [6] = { -- Flying
        [PANTS] = 0x212133,     -- Head
        [SHIRT] = 0x8352E0,     -- Body/Arms
        [GLOVES] = 0xF5F0FF,    -- ????
        [SHOES] = 0x8352E0,     -- ????
        [HAIR] = 0x893F3B,      -- Hair
        [SKIN] = 0xFFBA7C,      -- Skin
        [CAP] = 0x212133,       -- Spikes???
        [EMBLEM] = 0xFFC944,
    },
}

smash_add_character(
    "Waluigi",
    0.95,                           -- Weight (How much a part of knockback affects the character)
    1.1,                            -- Size of hurtbox
    52,                             -- Top Speed
    6,                              -- Acceleration
    6,                              -- Deceleration
    6,                              -- Friction
    texMenuCharWaluigi,
    E_MODEL_WALUIGI,                -- Character Model
    CT_WALUIGI,                     -- Character Override
    waluigi_mario_update,           -- Character Mario Update
    waluigi_before_mario_update,    -- Character Before Mario Update
    waluigi_stock_render,           -- Character Stock Icon Render
    waluigi_on_hud_render,
    -- Actions
    act_waluigi_jab,
    act_waluigi_aerial,
    act_waluigi_ground_pound,
    act_waluigi_ground_pound_a,
    act_waluigi_ground_pound_b,
    act_waluigi_slide_kick,
    act_waluigi_dash,
    palWaluigi
)