-- name: Super Smash Bros. Co-op v0.1
-- description: A semi-stable Smash Bros. gamemode for Super Mario 64 Co-op! After about two months, I've finally gotten around to finishing this project that was originally conceptualised in 2021 with SonicDark!\n\nFor Host Settings, press DPAD UP in the Character Selection screen. Left and Right Triggers to change Game Mode.\n\n As a warning, there are plenty of bugs in this release - I wouldn't consider it a full release just yet as there are features I haven't entirely tested and implemented. \n\n\\#FFE500\\Most notably: Try to stick to smaller room sizes! This mod was mostly tested with 2-5 players, and didn't seem to have the same bugs you'd encounter with higher player counts. \\#FFFFFF\\\n\nThis mod was made for the mods.sm64coopdx.com Game Mode Competition hosted by eeliottheking! 
-- ignore-script-warnings: true
hud_hide()

djui_hud_set_resolution(RESOLUTION_N64)

cursorX = djui_hud_get_screen_width()*0.5
cursorY = djui_hud_get_screen_height()*0.5

GAME_STATE_MENU_SELECT_STAGE = 0
GAME_STATE_MENU_SELECT_CHARACTER = 1
GAME_STATE_FIGHTING = 2

MENU_STATE_MAIN = 0
MENU_STATE_SETTINGS = 1
MENU_STATE_SETTINGS_PLAYERS = 2

GAME_MODE_SMASH = 0
GAME_MODE_STAMINA = 1
GAME_MODE_BOSS = 2
GAME_MODE_MAX = 3

LEVEL_SMASH_MENU            =   level_register('level_main_menu_entry',     COURSE_NONE,    'Smashdown Menu',       'menuwu',   28000, 0x28, 0x28, 0x28)
LEVEL_SMASH_DARK_WORLD      =   level_register('level_dark_world_entry',    COURSE_NONE,    'The Dark World',       'dark',     28000, 0x28, 0x28, 0x28)
LEVEL_SMASH_EARTH_CORE      =   level_register('level_earth_core_entry',    COURSE_NONE,    'The Earth\'s Core',    'gaia',     28000, 0x28, 0x28, 0x28)
LEVEL_SMASH_GOOMBA_FOREST   =   level_register('level_goomba_forest_entry', COURSE_NONE,    'Goomba Forest',        'goomba',   28000, 0x28, 0x28, 0x28)

gGlobalSyncTable.currentLevel = 1

gGlobalSyncTable.gameState = GAME_STATE_MENU_SELECT_STAGE

gGlobalSyncTable.gameMode = GAME_MODE_SMASH

gGlobalSyncTable.stocks = 3
gGlobalSyncTable.bossPlayer = 0


gHostRules = {
    players = {

    },
    bossHealth = 300,
    bossSize = 1.5,
}

for i=0, MAX_PLAYERS-1 do
    table.insert(gHostRules.players, {
        staminaHealth = 300,
        smashHealth = 0,
        stocks = 3,
    })
end
--[[{level = LEVEL_SMASH_DARK_WORLD,    name = "The Dark World",    texture = get_texture_info("menu-icon-arena-dark-world"),       radius = 4000, bottom = -2500, mus = nil},
    {level = LEVEL_SMASH_EARTH_CORE,    name = "Earth\'s Core",     texture = get_texture_info("menu-icon-arena-earth-core"),       radius = 5500, bottom = -3000, mus = {audio = audio_stream_load("mus-dark-gaia.mp3"), loopEnd = 203.428, loopOffset = -155.428}},
    {level = LEVEL_SMASH_GOOMBA_FOREST, name = "Goomba Forest",     texture = get_texture_info("menu-icon-arena-goomba-forest"),    radius = 3500, bottom = -2000, mus = nil},
]]
gSmashArenas = {
    
}

smash_add_stage(LEVEL_SMASH_DARK_WORLD, "The Dark World", get_texture_info("menu-icon-arena-dark-world"), 4000, -2500, nil)
smash_add_stage(LEVEL_SMASH_EARTH_CORE, "Earth\'s Core", get_texture_info("menu-icon-arena-earth-core"), 5500, -3000, {audio = audio_stream_load("mus-dark-gaia.mp3"), loopEnd = 203.428, loopOffset = -155.428})
smash_add_stage(LEVEL_SMASH_GOOMBA_FOREST, "Goomba Forest", get_texture_info("menu-icon-arena-goomba-forest"), 3500, -2000, nil)

selectedLevel = gSmashArenas[gGlobalSyncTable.currentLevel].level

ACT_MENU                = allocate_mario_action(ACT_FLAG_AIR)
ACT_SPECTATING          = allocate_mario_action(ACT_FLAG_AIR)

ACT_AIR_KNOCKBACK       = allocate_mario_action(ACT_FLAG_AIR)
ACT_GROUND_KNOCKBACK    = allocate_mario_action(ACT_FLAG_MOVING | ACT_FLAG_ATTACKING)
ACT_JAB_LIGHT           = allocate_mario_action(ACT_FLAG_STATIONARY | ACT_FLAG_ATTACKING)
ACT_KNOCKED_DOWN        = allocate_mario_action(ACT_FLAG_STATIONARY | ACT_FLAG_ATTACKING)
ACT_AERIAL              = allocate_mario_action(ACT_FLAG_AIR | ACT_FLAG_ATTACKING)
ACT_DASH                = allocate_mario_action(ACT_FLAG_MOVING | ACT_FLAG_ATTACKING)

ACT_GROUND_POUND_A      = allocate_mario_action(ACT_FLAG_AIR | ACT_FLAG_ATTACKING)
ACT_GROUND_POUND_B      = allocate_mario_action(ACT_FLAG_AIR | ACT_FLAG_ATTACKING)

E_MODEL_MENU_BACKGROUND = smlua_model_util_get_id("menu_background_geo")

texMenuCursor = get_texture_info("menu-icon-cursor")
texMenuCharacterBox = get_texture_info("menu-icon-char-box")
texMenuBoxBackground = get_texture_info("menu-icon-box-background")

function menu_update()
    local m = gMarioStates[0]

    gPlayerSyncTable[0].stocks = gHostRules.players[1].stocks
    if gNetworkPlayers[0].globalIndex == gGlobalSyncTable.bossPlayer and gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
        gPlayerSyncTable[0].stocks = 1
    end
    gPlayerSyncTable[0].alive = true

    cursorX = cursorX + m.controller.stickX*0.1
    cursorY = cursorY - m.controller.stickY*0.1

    djui_hud_set_resolution(RESOLUTION_N64)
    cursorX = clamp(cursorX, 0, djui_hud_get_screen_width()-26)
    cursorY = clamp(cursorY, 0, djui_hud_get_screen_height()-22)
    set_mario_action(m, ACT_MENU, 0)
end

function on_player_connected(m)
    local s = gPlayerSyncTable[m.playerIndex]
    s.alive = false
    s.stocks = 0
end

function menu_camera()
    --local cursorTex =
    camera_freeze()
    local m = gMarioStates[0]
    local l = gLakituState
    
    vec3f_set(l.curFocus, 1000, 0, 0)
    --vec3f_set(l.pos, 0, 200, -900)
    vec3f_set_dist_and_angle({x = 0, y = 0, z = 0}, l.pos, 850, 0, 0x8000)
    vec3f_set(l.pos, 0, 400, -850)
end

menuState = MENU_STATE_MAIN
menuPlayer = 1
menuPlayerOption = -1
palIndex = 1

function act_menu(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    if step == AIR_STEP_NONE then
        set_mario_animation(m, MARIO_ANIM_FIRST_PERSON)
        m.marioObj.header.gfx.angle.y = 0x8000+(gNetworkPlayers[m.playerIndex].globalIndex-((network_player_connected_count()-1)*0.5))*-0x200
        m.marioObj.header.gfx.angle.x = -0x500
        m.pos.x = (gNetworkPlayers[m.playerIndex].globalIndex-((network_player_connected_count()-1)*0.5))*-240
        m.pos.z = 500
        m.pos.y = -200
        m.vel.y = 0
    end
    
    if network_is_server() and m.playerIndex == 0 and menuState == MENU_STATE_MAIN then
        if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
            if gGlobalSyncTable.gameState == GAME_STATE_MENU_SELECT_STAGE then
                gGlobalSyncTable.gameState = GAME_STATE_MENU_SELECT_CHARACTER
            else
                if gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
                    local mBoss = gMarioStates[network_local_index_from_global(gGlobalSyncTable.bossPlayer)]
                    if not active_player(mBoss) then
                        djui_popup_create("Boss player index is not connected!\nChange the Boss Player in the player menu.", 2)
                        return
                    end
                end
                if network_player_connected_count() > 1 then
                    gGlobalSyncTable.gameState = GAME_STATE_FIGHTING
                else
                    djui_popup_create("Not enough players to start round!", 2)
                end
            end
        elseif (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            if (gGlobalSyncTable.gameState == GAME_STATE_MENU_SELECT_CHARACTER) then
                gGlobalSyncTable.gameState = GAME_STATE_MENU_SELECT_STAGE
            end
        end
    end
    local s = gPlayerSyncTable[m.playerIndex]
    if m.playerIndex == 0 then
        local charPal = gCharData[s.character].pal
        if menuState == MENU_STATE_MAIN then
            if (m.controller.buttonPressed & R_JPAD) ~= 0 then
                s.paletteIndex = s.paletteIndex + 1
            elseif (m.controller.buttonPressed & L_JPAD) ~= 0 then
                s.paletteIndex = s.paletteIndex - 1
            end
        end
        s.paletteIndex = clamp(s.paletteIndex, 1, #charPal+1)
        
    end

    if network_is_server() and m.playerIndex == 0 then
        if (m.controller.buttonPressed & U_JPAD) ~= 0 and menuState == MENU_STATE_MAIN and gGlobalSyncTable.gameState == GAME_STATE_MENU_SELECT_CHARACTER then
            menuState = MENU_STATE_SETTINGS_PLAYERS
        end
        if menuState == MENU_STATE_SETTINGS_PLAYERS then
            
            if (m.controller.buttonPressed & R_TRIG) ~= 0 then
                gGlobalSyncTable.gameMode = gGlobalSyncTable.gameMode + 1
            elseif (m.controller.buttonPressed & L_TRIG) ~= 0 then
                gGlobalSyncTable.gameMode = gGlobalSyncTable.gameMode - 1
            end
    
            if gGlobalSyncTable.gameMode < 0 then
                gGlobalSyncTable.gameMode = GAME_MODE_MAX-1
            elseif gGlobalSyncTable.gameMode > GAME_MODE_MAX-1 then
                gGlobalSyncTable.gameMode = 0
            end
    
            if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                menuState = MENU_STATE_MAIN
                menuPlayer = 1
                menuPlayerOption = -1
                gGlobalSyncTable.bossPlayer = menuPlayerBoss-1
                for i=1, MAX_PLAYERS-1 do
                    if active_player(gMarioStates[i]) then
                        network_send_to(i, true, {stocks = gHostRules.players[i+1].stocks, smashHealth = gHostRules.players[i+1].smashHealth, staminaHealth = gHostRules.players[i+1].staminaHealth, bossHealth = gHostRules.bossHealth, bossSize = gHostRules.bossSize})
                    end
                end
                menuState = MENU_STATE_MAIN
            end
            
            if (m.controller.buttonPressed & Y_BUTTON) ~= 0 then
                menuPlayerBoss = menuPlayer
            end

            if (m.controller.buttonPressed & D_JPAD) ~= 0 then
                menuPlayerOption = -1
                menuPlayer = menuPlayer + 1
            elseif (m.controller.buttonPressed & U_JPAD) ~= 0 then
                menuPlayerOption = -1
                menuPlayer = menuPlayer - 1
            end
    
            if (m.controller.buttonPressed & L_JPAD) ~= 0 then
                if menuPlayerOption == 0 then
                    if gGlobalSyncTable.gameMode == GAME_MODE_SMASH or gGlobalSyncTable.gameMode == GAME_MODE_STAMINA or (gGlobalSyncTable.gameMode == GAME_MODE_BOSS and gNetworkPlayers[menuPlayer-1].globalIndex ~= gGlobalSyncTable.bossPlayer) then
                        if gHostRules.players[menuPlayer].stocks > 1 then
                            gHostRules.players[menuPlayer].stocks = gHostRules.players[menuPlayer].stocks - 1
                        end
                    else
                        if gHostRules.bossSize > 0.4 then
                            gHostRules.bossSize = gHostRules.bossSize - 0.1
                        end
                    end
                elseif menuPlayerOption == 1 then
                    if gGlobalSyncTable.gameMode == GAME_MODE_SMASH then
                        if gHostRules.players[menuPlayer].smashHealth > 0 then
                            gHostRules.players[menuPlayer].smashHealth = gHostRules.players[menuPlayer].smashHealth - 10
                        end
                    elseif gGlobalSyncTable.gameMode == GAME_MODE_STAMINA then
                        if gHostRules.players[menuPlayer].staminaHealth > 10 then
                            gHostRules.players[menuPlayer].staminaHealth = gHostRules.players[menuPlayer].staminaHealth - 10
                        end
                    elseif gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
                        if gHostRules.bossHealth > 10 then
                            gHostRules.bossHealth = gHostRules.bossHealth - 10
                        end
                    end
                end
            elseif (m.controller.buttonPressed & R_JPAD) ~= 0 then
                if menuPlayerOption == 0 then
                    if gGlobalSyncTable.gameMode == GAME_MODE_SMASH or gGlobalSyncTable.gameMode == GAME_MODE_STAMINA or (gGlobalSyncTable.gameMode == GAME_MODE_BOSS and gNetworkPlayers[menuPlayer-1].globalIndex ~= gGlobalSyncTable.bossPlayer) then
                        if gHostRules.players[menuPlayer].stocks < 99 then
                            gHostRules.players[menuPlayer].stocks = gHostRules.players[menuPlayer].stocks + 1
                        end
                    else
                        if gHostRules.bossSize < 2.5 then
                            gHostRules.bossSize = gHostRules.bossSize + 0.1
                        end
                    end
                elseif menuPlayerOption == 1 then
                    if gGlobalSyncTable.gameMode == GAME_MODE_SMASH then 
                        gHostRules.players[menuPlayer].smashHealth = gHostRules.players[menuPlayer].smashHealth + 10
                    elseif gGlobalSyncTable.gameMode == GAME_MODE_STAMINA then
                        gHostRules.players[menuPlayer].staminaHealth = gHostRules.players[menuPlayer].staminaHealth + 10
                    elseif gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
                        gHostRules.bossHealth = gHostRules.bossHealth + 10
                    end
                end
            end
    
            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                menuPlayerOption = menuPlayerOption + 1
            end
            if menuPlayerOption > 1 then
                menuPlayerOption = -1
            end
            --menuPlayerOption = clamp(menuPlayerOption, -1, 1)
    
            menuPlayer = clamp(menuPlayer, 1, 16)
        end
    end
end

function act_spectating(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)

    if step == AIR_STEP_NONE then
        m.pos.x = 0
        m.pos.y = 2000
        m.pos.z = 0
    end
end


-- Base Actions
function act_idle(m)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    local charTbl = gCharData[s.character]
    local dcc = charTbl.dcc

    m.actionTimer = m.actionTimer + 1

    local step = perform_ground_step(m)
    if (m.actionArg == 1) then m.actionState = 1 m.actionArg = 0 end
    if step == (GROUND_STEP_NONE) or step == GROUND_STEP_HIT_WALL then
        if (m.actionState == 0) then
            mario_set_forward_vel(m, m.forwardVel*0.85)
            set_mario_animation(m, MARIO_ANIM_FIRST_PERSON)
            if m.intendedMag > 0 then
                m.faceAngle.y = m.intendedYaw
                set_mario_action(m, ACT_WALKING, 0)
            end
            if (m.controller.buttonDown & Z_TRIG) ~= 0 then
                m.actionState = 1
            end
            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                set_mario_action(m, ACT_JUMP, 0)
            end
            if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                set_mario_action(m, ACT_JAB_LIGHT, 0)
            end
        elseif (m.actionState == 1) then
            mario_set_forward_vel(m, m.forwardVel*0.95)
            set_mario_animation(m, MARIO_ANIM_CROUCHING)
            if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                set_mario_action(m, ACT_SLIDE_KICK, 0)
            end
            if (m.controller.buttonDown & Z_TRIG) == 0 then
                m.actionState = 0
            end
            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                set_mario_action(m, ACT_LONG_JUMP, 0)
            end
        end
    elseif step == GROUND_STEP_LEFT_GROUND then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

function act_knocked_down(m)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    local charTbl = gCharData[s.character]

    m.actionTimer = m.actionTimer + 1

    local step = perform_ground_step(m)
    if (m.actionArg == 1) then m.actionState = 1 m.actionArg = 0 end
    if step == GROUND_STEP_NONE or step == GROUND_STEP_HIT_WALL then
        if (m.actionState == 0) then
            mario_set_forward_vel(m, m.forwardVel*0.65)
            set_mario_animation(m, MARIO_ANIM_DYING_ON_STOMACH)
            
            if m.actionTimer > 20 then
                if (m.controller.buttonDown & Z_TRIG) ~= 0 and m.intendedMag > 0 then
                    set_mario_action(m, ACT_SIDE_FLIP, 0)
                    m.faceAngle.y = m.intendedYaw
                    mario_set_forward_vel(m, 48)
                    m.vel.y = 32
                end
                if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                    set_mario_action(m, ACT_DOUBLE_JUMP, 0)
                end
                if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                    set_mario_action(m, ACT_JAB_LIGHT, 0)
                end
            else m.particleFlags = m.particleFlags | PARTICLE_FIRE end
        end
    elseif step == GROUND_STEP_LEFT_GROUND then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL, 0)
    end
end

function act_walking(m)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    local charTbl = gCharData[s.character]
    local topSpeed = charTbl.topSpeed
    local acc = charTbl.acc
    local dcc = charTbl.dcc
    local frc = charTbl.frc

    local targetTop = (m.intendedMag/32)*topSpeed

    m.actionTimer = m.actionTimer + 1

    local step = perform_ground_step(m)

    if step == (GROUND_STEP_NONE) or step == GROUND_STEP_HIT_WALL then
        local startYaw = m.faceAngle.y
        if (m.actionState == 0) then
            local turnSpeed = (0x100)*(m.forwardVel*0.2)
            m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, turnSpeed, turnSpeed)
            local animSpeed = (m.forwardVel * 3.0 * 0x1000)
            local anim = MARIO_ANIM_WALKING
            if m.forwardVel >= topSpeed * 0.5 then
                anim = MARIO_ANIM_RUNNING
            end
            set_mario_anim_with_accel(m, anim, animSpeed)
            if (analog_stick_held_back(m) ~= 0) then
                m.actionState = 1
                m.actionTimer = 0
                e.animFrame = 0
            end
            if m.forwardVel < 12 then
                m.faceAngle.y = m.intendedYaw
            end
            m.forwardVel = approach_f32(m.forwardVel, targetTop, acc, dcc)
            mario_set_forward_vel(m, m.forwardVel)
            if m.forwardVel <= 0 or m.intendedMag < 8 then
                set_mario_action(m, ACT_IDLE, 0)
            end
            tilt_body_walking(m, startYaw)
            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                set_mario_action(m, ACT_JUMP, 0)
            end
        elseif (m.actionState == 1) then -- skidding
            m.forwardVel = approach_f32(m.forwardVel, 0, frc, frc)
            mario_set_forward_vel(m, m.forwardVel)
            set_mario_anim_with_accel(m, MARIO_ANIM_SKID_ON_GROUND, 0)
            if not (analog_stick_held_back(m) ~= 0) then
                m.actionState = 0
                e.animFrame = 0
                m.actionTimer = 0
            end
            if m.forwardVel < topSpeed*0.1 or (m.actionTimer < 4 and not (analog_stick_held_back(m) ~= 0)) then
                m.faceAngle.y = m.intendedYaw
                m.forwardVel = targetTop*1.2--approach_f32(m.forwardVel, targetTop, frc, frc)
                mario_set_forward_vel(m, m.forwardVel)
                m.actionState = 0
                e.animFrame = 0
                m.actionTimer = 0
            end
            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                set_mario_action(m, ACT_SIDE_FLIP, 0)
            end
        end
        if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            if (m.forwardVel > topSpeed * 0.95 and (m.controller.buttonDown & A_BUTTON) == 0) then
                set_mario_action(m, ACT_DASH, 0)
            else
                set_mario_action(m, ACT_JAB_LIGHT, 0)
            end
        end

        
        if (m.controller.buttonDown & Z_TRIG) ~= 0 then
            set_mario_action(m, ACT_IDLE, 1)
        end
        
            
        
    elseif step == GROUND_STEP_LEFT_GROUND then
        set_mario_action(m, ACT_FREEFALL, 0)
        m.vel.y = 0
    end
end

function act_air_knockback(m)
    local step = perform_air_step(m, AIR_STEP_CHECK_LEDGE_GRAB)
    m.actionTimer = m.actionTimer + 1
    if (step == AIR_STEP_NONE) then
        if m.actionState == 0 then
            set_mario_animation(m, MARIO_ANIM_BACKWARD_AIR_KB)
            m.vel.x = m.vel.x * 0.94
            m.vel.y = m.vel.y + 1
            m.vel.z = m.vel.z * 0.94
            --m.forwardVel = atan2s(m.vel.z, m.vel.x)
            if m.actionTimer > 25 and (math.sqrt(sqrf(m.vel.x)*sqrf(m.vel.z)) < 32 or m.vel.y <= -24) then
                m.actionState = 1
                m.actionTimer = 0
            end
            m.particleFlags = m.particleFlags | PARTICLE_DUST
            
        elseif m.actionState == 1 then
            set_mario_animation(m, MARIO_ANIM_BACKWARD_AIR_KB)
            m.marioObj.header.gfx.angle.x = m.actionTimer * -0x800
            m.marioObj.header.gfx.angle.y = m.faceAngle.y + 0x8000
            if (m.controller.buttonDown & Z_TRIG) ~= 0 then
                set_mario_action(m, ACT_GROUND_POUND, 0)
            elseif (m.controller.buttonDown & B_BUTTON) ~= 0 then
                set_mario_action(m, ACT_AERIAL, 0)
            end
        end
    elseif (step == AIR_STEP_LANDED) then
        m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
        if m.actionTimer <= 25 and m.vel.y <= -20 and m.actionArg == 0 then
            m.actionArg = 1
            m.actionState = 1
            m.actionTimer = 0
            m.vel.y = m.vel.y*-0.75
        else 
            set_mario_action(m, ACT_KNOCKED_DOWN, 0)
        end
    elseif (step == AIR_STEP_HIT_WALL) then
        m.actionTimer = 0
        mario_bonk_reflection(m, false)
        mario_set_forward_vel(m, vec3f_length({x = m.vel.x, y = 0, z = m.vel.z}))
        m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
    end
end

function act_ground_knockback(m)
    local step = perform_ground_step(m)
    m.actionTimer = m.actionTimer + 1
    if (step == GROUND_STEP_NONE or step == GROUND_STEP_HIT_WALL) then
        m.vel.x = m.vel.x * 0.8
        m.vel.z = m.vel.z * 0.8
        if m.actionTimer > 5 and math.sqrt(sqrf(m.vel.x)*sqrf(m.vel.z)) < 8 then
            set_mario_action(m, ACT_IDLE, 0)
        end
    elseif (step == GROUND_STEP_LEFT_GROUND) then
        m.vel.y = 0
        return set_mario_action(m, ACT_FREEFALL, 0)
    end
end

-- Character Actions
function act_ground_pound_a(m)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    gCharData[s.character].groundPoundA(m)
end

function act_ground_pound_b(m)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    gCharData[s.character].groundPoundB(m)
end

function act_ground_pound(m)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    gCharData[s.character].groundPound(m)
end

function act_slide_kick(m)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    gCharData[s.character].slideKick(m)
end

function act_forward_rollout(m)
    local step = perform_ground_step(m)
    local e = gMarioStateExtras[m.playerIndex]

    if (step == GROUND_STEP_NONE) then
        --stopping_step(m, MARIO_ANIM_CROUCH_FROM_SLIDE_KICK, ACT_CROUCHING);
    end
end

function act_jab_light(m)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    gCharData[s.character].jab(m)
end

function act_aerial(m)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    gCharData[s.character].aerial(m)
end

function act_dash(m)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    gCharData[s.character].dash(m)
end

smashCam = 1

camTbl = {
    "Smash Cam",
    "Vanilla Cam",
    "Freecam"
}

function command_cam(msg)
    smashCam = smashCam + 1
    if smashCam > 3 then smashCam = 1 end
    if camTbl[smashCam] ~= nil then
        djui_chat_message_create("Toggled Smash Cam: "..camTbl[smashCam])
    end

    return true
end

hook_chat_command("smash_cam", "Toggle between the Smash and Vanilla cameras.", command_cam)

function mario_update(m)

    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]

    local charPal = gCharData[s.character].pal
    
    for i= 0, PLAYER_PART_MAX-1 do

        if s.paletteIndex > #charPal then
            network_player_reset_override_palette(gNetworkPlayers[m.playerIndex])
        else
            local rgb = {r = 0, g = 0, b = 0}
    
            local currPal = charPal[s.paletteIndex][i] --- Problem
    
            rgb.r = (currPal & 0xFF0000) >> (8*2)
            rgb.g = (currPal & 0x00FF00) >> (8*1)
            rgb.b = (currPal & 0x0000FF) >> (8*0)
    
            network_player_set_override_palette_color(gNetworkPlayers[m.playerIndex], i, rgb)
        end

    end

    m.peakHeight = m.pos.y
    m.invincTimer = 1
    --s.character = CT_BOWSER
    if m.action & ACT_FLAG_AIR == 0 then
        e.groundPoundA = true
    end
    e.hitTimer = e.hitTimer + 1
    e.healthOffset = e.healthOffset * -0.5
    if math.abs(e.healthOffset) < 0.01 then
        e.healthOffset = 0
    end

    m.marioObj.header.gfx.scale.x, m.marioObj.header.gfx.scale.y, m.marioObj.header.gfx.scale.z = s.scale, s.scale, s.scale

    if m.playerIndex ~= 0 then return end
    
    if gNetworkPlayers[0].globalIndex == gGlobalSyncTable.bossPlayer and gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
        s.scale = gHostRules.bossSize
    else
        s.scale = 1
    end
    if (s.stocks <= 0) then
        s.alive = false
    else
        s.alive = true
    end

    if not s.alive and m.action ~= ACT_SPECTATING then
        set_mario_action(m, ACT_SPECTATING, 0)
    end

    if (m.action == ACT_GROUND_POUND_LAND) and (m.controller.buttonPressed & A_BUTTON) ~= 0 then
        set_mario_action(m, ACT_TRIPLE_JUMP, 0)
    end

    if gNetworkPlayers[0].globalIndex == gGlobalSyncTable.bossPlayer and gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
        s.hp = clamp(s.hp, 0, gHostRules.bossHealth)
    end

    

    if (gGlobalSyncTable.gameState == GAME_STATE_FIGHTING) then
        camera_unfreeze()
        if smashCam == 1 then
            smash_camera()
        elseif smashCam == 2 then
            camera_config_enable_free_cam(false)
        elseif smashCam == 3 then
            camera_config_enable_free_cam(true)
        end
    end

    gCharData[s.character].charMarioUpdate(m)

    if m.action == ACT_FLYING_TRIPLE_JUMP then
        m.faceAngle.y = m.intendedYaw
    end

    if m.pos.y < gSmashArenas[gGlobalSyncTable.currentLevel].bottom or vec3f_dist({x = m.pos.x, y = 0, z = m.pos.z}, {x = 0, y = 0, z = 0}) > gSmashArenas[gGlobalSyncTable.currentLevel].radius or (m.pos.y > 3000 and m.action == ACT_AIR_KNOCKBACK) or (gGlobalSyncTable.gameMode == GAME_MODE_STAMINA and gPlayerSyncTable[0].hp <= 0) or (gGlobalSyncTable.gameMode == GAME_MODE_BOSS and gPlayerSyncTable[0].hp <= 0 and gNetworkPlayers[0].globalIndex == gGlobalSyncTable.bossPlayer) then
        player_respawn(m, true)
    end

    if (m.controller.buttonPressed & Z_TRIG) ~= 0 and m.action == ACT_LONG_JUMP then
        set_mario_action(m, ACT_GROUND_POUND, 0)
    end

    if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
        if (m.controller.buttonDown & A_BUTTON) ~= 0 then
            
        else
        end
    end
    if (m.input & INPUT_IN_POISON_GAS) ~= 0 and (get_network_area_timer() % 6) == 0 then
        if gGlobalSyncTable.gameMode == GAME_MODE_SMASH or (gGlobalSyncTable.gameMode == GAME_MODE_BOSS and gGlobalSyncTable.bossPlayer ~= gNetworkPlayers[0].globalIndex) then
            s.hp = s.hp + 2.4
        else
            s.hp = s.hp - 4.8
        end
    end
    m.health = 0x880
end

function before_phys_step(m)
    --m.intendedYaw = math.floor(m.intendedYaw/0x8000)*0x8000+0x4000
end

function before_mario_update(m)
    local e = gMarioStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    obj_set_model_extended(m.marioObj, gCharData[s.character].model)
    --m.character.type = gCharData[s.character].charType
    gNetworkPlayers[m.playerIndex].overrideModelIndex = gCharData[s.character].charType
    if m.playerIndex ~= 0 then return end
    gCharData[s.character].charBeforeMarioUpdate(m)
end

function on_set_mario_action(m)
    local e = gMarioStateExtras[m.playerIndex]
    e.animFrame = 0
    -- Jabbing State
    if (m.action == ACT_PUNCHING or m.action == ACT_MOVE_PUNCHING) then
        return set_mario_action(m, ACT_JAB_LIGHT, 0)
    end

    if (m.action == ACT_JUMP_KICK or (m.action == ACT_DIVE and m.prevAction ~= ACT_GROUND_POUND and (m.prevAction & ACT_FLAG_AIR) ~= 0)) then
        return set_mario_action(m, ACT_AERIAL, 0)
    end

    if (m.action == ACT_DIVE) then
        set_mario_action(m, ACT_DASH, 0)
    end

    if (m.prevAction == ACT_EATEN) then
        cur_obj_enable_rendering_and_become_tangible(m.marioObj)
    end

    if (m.prevAction == ACT_LEDGE_GRAB) then
        if (m.action == ACT_SOFT_BONK) then
            m.faceAngle.y = m.faceAngle.y + 0x8000
            m.vel.y = 24
            mario_set_forward_vel(m, 24)
            set_mario_action(m, ACT_WALL_KICK_AIR, 0)
        end
    end
    if (m.action == ACT_LEDGE_CLIMB_SLOW_1 or m.action == ACT_LEDGE_CLIMB_FAST) then
        m.vel.y = 48
        set_mario_action(m, ACT_BACKFLIP, 0)
        e.groundPoundA = true
        e.groundPoundB = true
    end
end

function on_death(m)
    return false
end

function player_respawn(m, killed)
    local angle = 0x10000*(gNetworkPlayers[0].globalIndex/aliveCount)
    init_single_mario(m)
    copyCharIndex = 2
    soft_reset_camera(m.area.camera)
    m.pos.x = 1500*sins(angle)
    m.pos.y = 100
    m.pos.z = 1500*coss(angle)

    m.faceAngle.y = angle+0x8000

    m.vel.x = 0
    m.vel.y = 0
    m.vel.z = 0
    if killed then
        gPlayerSyncTable[0].stocks = gPlayerSyncTable[0].stocks - 1
    end
    if gGlobalSyncTable.gameMode == GAME_MODE_SMASH then
        gPlayerSyncTable[0].hp = gHostRules.players[1].smashHealth
    elseif gGlobalSyncTable.gameMode == GAME_MODE_STAMINA then
        gPlayerSyncTable[0].hp = gHostRules.players[1].staminaHealth
    elseif gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
        -- If the player, set health to funny health. Otherwise, cunk.
        if gGlobalSyncTable.bossPlayer ~= gNetworkPlayers[0].globalIndex then
            gPlayerSyncTable[0].hp = gHostRules.players[1].smashHealth
        else
            gPlayerSyncTable[0].hp = gHostRules.bossHealth
        end
    end
    gPlayerSyncTable[0].copyAbility = gPlayerSyncTable[0].character
    set_mario_action(m, ACT_FREEFALL, 0)

    mario_set_forward_vel(m, 0)

    m.health = 0x880
end
                                               -----------------------------------------------
-----------------------------------------------
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
menuPlayerBoss = 1

function render_match_settings(x, y)
    djui_hud_set_clamped_color(255, 255, 255, 182)
    djui_hud_render_rect(x, 23, 129, djui_hud_get_screen_height()-46)
    djui_hud_set_clamped_color(20, 20, 20, 182)
    djui_hud_render_rect(x, 24, 128, djui_hud_get_screen_height()-48)

    djui_hud_set_clamped_color(255, 255, 255, 255)

    if (menuState == MENU_STATE_SETTINGS) then
        
    elseif (menuState == MENU_STATE_SETTINGS_PLAYERS) then
        local gameModeText = "SMASH (%)"

        if gGlobalSyncTable.gameMode == GAME_MODE_STAMINA then
            gameModeText = "STAMINA (HP)"
        elseif gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
            gameModeText = "BOSS SMASH"
        end

        djui_hud_print_text("GAME MODE: "..gameModeText, 32, 25, 0.25)
        for i=0, MAX_PLAYERS-1 do
            local offsetX = 0
            djui_hud_set_clamped_color(200, 200, 200, 255)
            if menuPlayer == i+1 then
                offsetX = 2
                djui_hud_set_clamped_color(255, 255, 255, 255)
            end

            djui_hud_print_text(gNetworkPlayers[i].name, 4+offsetX, 35+i*11, 0.25)
            if i == menuPlayerBoss-1 and gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
                djui_hud_set_clamped_color(255, 85, 155, 255)
                djui_hud_print_text("|BOSS|", 48+offsetX, 35+i*11, 0.25)
                
            end
            if menuPlayerOption == 0 and menuPlayer == i+1 then
                djui_hud_set_clamped_color(50, 255, 50, 255)
            else
                djui_hud_set_clamped_color(200, 200, 200, 255)
            end
            if gGlobalSyncTable.gameMode == GAME_MODE_SMASH or gGlobalSyncTable.gameMode == GAME_MODE_STAMINA or (gGlobalSyncTable.gameMode == GAME_MODE_BOSS and gNetworkPlayers[i].globalIndex ~= gGlobalSyncTable.bossPlayer) then
                djui_hud_print_text("STK:"..gHostRules.players[i+1].stocks, 65+offsetX, 35+i*11, 0.25)
            else
                djui_hud_print_text("SIZE:"..gHostRules.bossSize, 65+offsetX, 35+i*11, 0.25)
            end
            if gGlobalSyncTable.gameMode == GAME_MODE_SMASH then
                if menuPlayerOption == 1 and menuPlayer == i+1 then
                    djui_hud_set_clamped_color(50, 255, 50, 255)
                else
                    djui_hud_set_clamped_color(200, 200, 200, 255)
                end
                djui_hud_print_text("HP:"..gHostRules.players[i+1].smashHealth.."%", 85+offsetX, 35+i*11, 0.25)
            elseif gGlobalSyncTable.gameMode == GAME_MODE_STAMINA then
                if menuPlayerOption == 1 and menuPlayer == i+1 then
                    djui_hud_set_clamped_color(50, 255, 50, 255)
                else
                    djui_hud_set_clamped_color(200, 200, 200, 255)
                end
                djui_hud_print_text("HP:"..gHostRules.players[i+1].staminaHealth.."HP", 85+offsetX, 35+i*11, 0.25)
            elseif gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
                if menuPlayerOption == 1 and menuPlayer == i+1 then
                    djui_hud_set_clamped_color(50, 255, 50, 255)
                else
                    djui_hud_set_clamped_color(200, 200, 200, 255)
                end
                djui_hud_print_text("MAX HP:"..gHostRules.bossHealth, 85+offsetX, 35+i*11, 0.25)
            end
        end
    end
end

local bossHealthLower = 0

function on_hud_render()
    --djui_chat_message_create("Sob."..tostring(gPlayerSyncTable[0].hp))
    --djui_hud_set_filter(FILTER_LINEAR)
    djui_hud_set_resolution(RESOLUTION_N64)
    djui_hud_set_font(FONT_NORMAL)
    

    gCharData[gPlayerSyncTable[0].character].hudRender()
    printName = gCharData[gPlayerSyncTable[0].character].name
    if gGlobalSyncTable.gameState == GAME_STATE_MENU_SELECT_STAGE then
        printName = gSmashArenas[gGlobalSyncTable.currentLevel].name
    end
    
    if gGlobalSyncTable.gameState ~= GAME_STATE_FIGHTING then
        djui_hud_print_text_outline(printName, djui_hud_get_screen_width()*0.5-djui_hud_measure_text(printName)*0.25, 128, 0xFFFFFF, 0x222222, 0.5)
    end
    djui_hud_set_color(255, 255, 255, 255)

    local palTbl = {
        r = 0, g = 0, b = 0
    }
    if gGlobalSyncTable.gameState == GAME_STATE_MENU_SELECT_CHARACTER then
        local boxPosX = 0
        local boxPosY = 0
        local boxPerRow = math.ceil(#gCharData*0.5)
        local boxTableOffsetX = -48+(djui_hud_get_screen_width()*0.5)-boxPerRow*24
        for i=1, #gCharData do
            
            boxPosX = boxPosX + 48
            if boxPosX > boxPerRow*48 then
                boxPosY = boxPosY + 48
                boxPosX = 48
            end
            djui_hud_render_texture(texMenuBoxBackground, boxPosX+boxTableOffsetX, boxPosY, 1, 1)
            djui_hud_render_texture(gCharData[i].charIcon, boxPosX+boxTableOffsetX, boxPosY, 1, 1)
            djui_hud_render_texture(texMenuCharacterBox, boxPosX+boxTableOffsetX, boxPosY, 1, 1)

            local inBox = cursorX > boxPosX+boxTableOffsetX and cursorX < boxPosX+48+boxTableOffsetX and cursorY > boxPosY and cursorY < boxPosY+48

            if inBox then
                gPlayerSyncTable[0].character = i
            end
            
        end
        djui_hud_render_texture(texMenuCursor, math.floor(cursorX), math.floor(cursorY), 1, 1)

        if (menuState ~= MENU_STATE_MAIN) then
            render_match_settings(0, 0)
        end

    elseif gGlobalSyncTable.gameState == GAME_STATE_MENU_SELECT_STAGE then
        local boxPosX = 0
        local boxPosY = 0
        local boxPerRow = math.ceil(#gSmashArenas*0.5)
        local boxTableOffsetX = -48+(djui_hud_get_screen_width()*0.5)-boxPerRow*24
        for i=1, #gSmashArenas do
            
            boxPosX = boxPosX + 48
            if boxPosX > boxPerRow*48 then
                boxPosY = boxPosY + 48
                boxPosX = 48
            end
            djui_hud_render_texture(gSmashArenas[i].texture, boxPosX+boxTableOffsetX, boxPosY, 1, 1)
            djui_hud_render_texture(texMenuCharacterBox, boxPosX+boxTableOffsetX, boxPosY, 1, 1)

            local inBox = cursorX > boxPosX+boxTableOffsetX and cursorX < boxPosX+48+boxTableOffsetX and cursorY > boxPosY and cursorY < boxPosY+48

            if inBox and network_is_server() then
                gGlobalSyncTable.currentLevel = i
            end
            
        end
        djui_hud_render_texture(texMenuCursor, math.floor(cursorX), math.floor(cursorY), 1, 1)
    else
        local activeOffset = 0
        if gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
            djui_hud_set_color(10, 0, 20, 255)
            djui_hud_render_rect(18, 11, djui_hud_get_screen_width()-30, 1)
            djui_hud_render_rect(17, 12, djui_hud_get_screen_width()-30, 1)
            djui_hud_render_rect(16, 13, djui_hud_get_screen_width()-30, 1)
            djui_hud_render_rect(15, 14, djui_hud_get_screen_width()-30, 1)

            local mBoss = gMarioStates[network_local_index_from_global(gGlobalSyncTable.bossPlayer)]

            local bossName = gNetworkPlayers[mBoss.playerIndex].name

            if gMarioStateExtras[mBoss.playerIndex].hitTimer > 20 then
                bossHealthLower = lerp(bossHealthLower, gPlayerSyncTable[mBoss.playerIndex].hp, 0.4)
            end

            djui_hud_render_texture(gCharData[gPlayerSyncTable[mBoss.playerIndex].character].charIcon, 0, 0, 1, 1)
            djui_hud_render_texture(gCharData[gPlayerSyncTable[mBoss.playerIndex].character].charIcon, 2, 0, 1, 1)
            djui_hud_render_texture(gCharData[gPlayerSyncTable[mBoss.playerIndex].character].charIcon, 0, 2, 1, 1)
            djui_hud_render_texture(gCharData[gPlayerSyncTable[mBoss.playerIndex].character].charIcon, 2, 2, 1, 1)

            -- Lower White Bar
            djui_hud_set_clamped_color(255, 200, 100, 255)
            djui_hud_render_rect(56, 12, (djui_hud_get_screen_width()-72)*(bossHealthLower/gHostRules.bossHealth), 1)
            djui_hud_render_rect(55, 13, (djui_hud_get_screen_width()-72)*(bossHealthLower/gHostRules.bossHealth), 1)

            djui_hud_set_clamped_color(255, 100, 255, 255)
            djui_hud_render_rect(56, 12, (djui_hud_get_screen_width()-72)*(gPlayerSyncTable[mBoss.playerIndex].hp/gHostRules.bossHealth), 1)
            djui_hud_render_rect(55, 13, (djui_hud_get_screen_width()-72)*(gPlayerSyncTable[mBoss.playerIndex].hp/gHostRules.bossHealth), 1)
            djui_hud_set_clamped_color(255, 255, 255, 255)

            djui_hud_set_font(FONT_NORMAL)

            djui_hud_render_texture(gCharData[gPlayerSyncTable[mBoss.playerIndex].character].charIcon, 1, 1, 1, 1)
            djui_hud_print_text_outline(bossName, 56, 20, 0xFFFFFF, 0x332255, 0.5)
        end
        for i=0, MAX_PLAYERS-1 do
            local e = gMarioStateExtras[i]
            
            --[[if gNetworkPlayers[i].globalIndex == gGlobalSyncTable.bossPlayer and gGlobalSyncTable.gameMode == GAME_MODE_BOSS then
                
                local healthCol = clamp(255-e.hitTimer*80, 0, 255);

                djui_hud_render_texture(gCharData[i+1].charIcon, 4, 4, 1, 1)
                djui_hud_set_clamped_color(255, 100+(e.hitTimer*80), 255, 255)
                djui_hud_render_rect(16, 12, (djui_hud_get_screen_width()-32)*(gPlayerSyncTable[i].hp/gHostRules.bossHealth), 2)
            end]]
            if gPlayerSyncTable[i].alive and not (gNetworkPlayers[i].globalIndex == gGlobalSyncTable.bossPlayer and gGlobalSyncTable.gameMode == GAME_MODE_BOSS) then
                local colour = get_color(gPlayerSyncTable[i].hp)
                
                local healthCol = clamp(255-e.hitTimer*80, 0, 255);
                djui_hud_set_clamped_color(colour.r+healthCol, colour.g+healthCol, colour.b+healthCol, 255)
                local offset = 1/(aliveCount)
                
                local symbol = "%"

                if gGlobalSyncTable.gameMode == GAME_MODE_STAMINA then
                    symbol = "/"
                end
                render_text(math.ceil(gPlayerSyncTable[i].hp)..symbol, nil, djui_hud_get_screen_width()*offset-96+activeOffset*96, djui_hud_get_screen_height()-60, 8, 2, nil) -- Outline
    
                render_text(math.ceil(gPlayerSyncTable[i].hp)..symbol, nil, djui_hud_get_screen_width()*offset-96+activeOffset*96, djui_hud_get_screen_height()-60, 8, 0, e) -- Main
    
                
                for o=1, gPlayerSyncTable[i].stocks do
                    gCharData[gPlayerSyncTable[i].character].stockRender(djui_hud_get_screen_width()*offset-96+activeOffset*96+o*18, djui_hud_get_screen_height()-20, i, palTbl)
                end
                activeOffset = activeOffset + 1
            end
            
        end
        
    end
end

function on_sync_valid()
    local np = gNetworkPlayers[0]
    if gGlobalSyncTable.gameState == GAME_STATE_FIGHTING then
        if np.currLevelNum ~= selectedLevel then
            warp_to_level(selectedLevel, 1, 1)
        end
        if (gPlayerSyncTable[0].alive) then
            player_respawn(gMarioStates[0], false)
        end
    end
end

aliveCount = 0

function command_smash_help(msg)
    triggered = false

    return true
end

hook_chat_command("smash_help", "Instructions for how to play!", command_smash_help)

triggered = false

function on_update()
    
    selectedLevel = gSmashArenas[gGlobalSyncTable.currentLevel].level

    if not triggered then
        djui_chat_message_create("--------")
        djui_chat_message_create("\\#FFFF00\\Welcome to Co-op Smash!")
        djui_chat_message_create("Moves are as follows:")
        djui_chat_message_create("Grounded + B + Idle    = Jab")
        djui_chat_message_create("Grounded + B + Running = Dash Attack")
        djui_chat_message_create("Grounded + B + Crouch  = Special")
        djui_chat_message_create("Aerial + B             = Aerial")
        djui_chat_message_create("Ground Pound + A       = Recovery")
        djui_chat_message_create("Ground Pound + B       = Ground Pound Dive")
        djui_chat_message_create("\\#FFFF00\\Certain characters have unique properties.")
        djui_chat_message_create("By pressing \\#FFFF00\\DPAD UP\\#FFFFFF\\ as \\#FFD36D\\Emerl\\#FFFFFF\\, you can choose from any available character's attacks. These will be saved to mod storage!")
        djui_chat_message_create("By using \\#FFA3F5\\Kirby's\\#FFFFFF\\ \\#FFFF00\\Inhale (Special)\\#FFFFFF\\, you can either copy an opponent by pressing A or spit them out by pressing B! These abilities will be lost upon dying.")
        djui_chat_message_create("--------")

        triggered = true
    end

    music_update()
    if gGlobalSyncTable.gameState == GAME_STATE_MENU_SELECT_CHARACTER or gGlobalSyncTable.gameState == GAME_STATE_MENU_SELECT_STAGE then
        menu_camera()
    end
    local np = gNetworkPlayers[0]
    if np.currAreaSyncValid then
        if gGlobalSyncTable.gameState == GAME_STATE_MENU_SELECT_CHARACTER or gGlobalSyncTable.gameState == GAME_STATE_MENU_SELECT_STAGE then
            if np.currLevelNum ~= LEVEL_SMASH_MENU then
                warp_to_level(LEVEL_SMASH_MENU, 1, 1)
            end
            menu_update()
        else
            if np.currLevelNum ~= selectedLevel then
                warp_to_level(selectedLevel, 1, 1)
            end
            aliveCount = 0
            for i=0, MAX_PLAYERS-1 do
                if gPlayerSyncTable[i].alive then
                    aliveCount = aliveCount + 1
                end
            end
            local mBoss = gMarioStates[network_local_index_from_global(gGlobalSyncTable.bossPlayer)]
            local bossDead = not gPlayerSyncTable[mBoss.playerIndex].alive and gGlobalSyncTable.gameMode == GAME_MODE_BOSS
            if (aliveCount == 1 or bossDead) then
                gGlobalSyncTable.gameState = GAME_STATE_MENU_SELECT_STAGE
            end
        end
    end
end

function on_packet_host_receive(dataTable)
    if dataTable.stocks ~= nil then
        gHostRules.players[1].stocks = dataTable.stocks
    end
    if dataTable.smashHealth ~= nil then
        gHostRules.players[1].smashHealth = dataTable.smashHealth
    end
    if dataTable.staminaHealth ~= nil then
        gHostRules.players[1].staminaHealth = dataTable.staminaHealth
    end
    if dataTable.bossHealth ~= nil then
        gHostRules.bossHealth = dataTable.bossHealth
    end
    if dataTable.bossSize ~= nil then
        gHostRules.bossSize = dataTable.bossSize
    end
end

hook_event(HOOK_ON_PACKET_RECEIVE, on_packet_host_receive)

function on_level_init()

    

    copyCharIndex = 2
    if (gPlayerSyncTable[0].alive) then
        player_respawn(gMarioStates[0], false)
    end
    --player_respawn(gMarioStates[0], false)
    camera_unfreeze()
    --spawn_non_sync_object(id_bhvMenuBackground, E_MODEL_MENU_BACKGROUND, 0, 0, 0, function(obj) end)
end

function command_health(msg)
    if (tonumber(msg)) then
        gPlayerSyncTable[0].hp = tonumber(msg)
        gPlayerSyncTable[0].stocks = 3
    end
    return true
end

function command_character(msg)
    local msg = string.lower(msg)

    --[[
    if (msg == "mario") then
        gPlayerSyncTable[0].character = CT_MARIO
    elseif (msg == "luigi") then
        gPlayerSyncTable[0].character = CT_LUIGI
    elseif (msg == "toad") then
        --djui_chat_message_create("UNFINISHED")
        gPlayerSyncTable[0].character = CT_TOAD
    elseif (msg == "waluigi") then
        gPlayerSyncTable[0].character = CT_WALUIGI
    elseif (msg == "wario") then
        gPlayerSyncTable[0].character = CT_WARIO
    elseif (msg == "bowser") then
        gPlayerSyncTable[0].character = CT_BOWSER
    end]]

    if (msg == "dw") then
        gGlobalSyncTable.currentLevel = LEVEL_SMASH_DARK_WORLD
        djui_chat_message_create("Dark World"..LEVEL_SMASH_DARK_WORLD)
    elseif (msg == "gf") then
        gGlobalSyncTable.currentLevel = LEVEL_SMASH_GOOMBA_FOREST
        djui_chat_message_create("Goomba Forest"..LEVEL_SMASH_GOOMBA_FOREST)
    end
    return true
end

function on_health_changed(tag, oldVal, newVal)
    local e = gMarioStateExtras[tag]

    e.healthOffset = 10;
    e.hitTimer = 0;
    e.healthDirection = math.random(360)
end

hook_event(HOOK_BEFORE_PHYS_STEP, before_phys_step)
hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_BEFORE_MARIO_UPDATE, before_mario_update)
hook_event(HOOK_ON_SET_MARIO_ACTION, on_set_mario_action)
hook_event(HOOK_ON_HUD_RENDER, on_hud_render)
hook_event(HOOK_ON_SYNC_VALID, on_sync_valid)
hook_event(HOOK_ON_LEVEL_INIT, on_level_init)
hook_event(HOOK_UPDATE, on_update)

hook_event(HOOK_ON_DEATH, on_death)

hook_event(HOOK_ON_PLAYER_CONNECTED, on_player_connected)
hook_event(HOOK_ON_PLAYER_DISCONNECTED, on_player_connected)

hook_mario_action(ACT_MENU,                     act_menu)
hook_mario_action(ACT_SPECTATING,               act_spectating)

hook_mario_action(ACT_AIR_KNOCKBACK,            act_air_knockback)
hook_mario_action(ACT_GROUND_KNOCKBACK,         act_ground_knockback)
hook_mario_action(ACT_JAB_LIGHT,                act_jab_light)
hook_mario_action(ACT_GROUND_POUND,             act_ground_pound)
hook_mario_action(ACT_GROUND_POUND_A,           act_ground_pound_a)
hook_mario_action(ACT_GROUND_POUND_B,           act_ground_pound_b)
hook_mario_action(ACT_SLIDE_KICK,               act_slide_kick)
hook_mario_action(ACT_AERIAL,                   act_aerial)
hook_mario_action(ACT_DASH,                     act_dash)
hook_mario_action(ACT_WALKING,                  act_walking)
hook_mario_action(ACT_IDLE,                     act_idle)
hook_mario_action(ACT_KNOCKED_DOWN,             act_knocked_down)

_G.smash = {
    smash_add_character = smash_add_character,
    smash_add_character = smash_add_stage,
    create_hitbox = create_hitbox,
    gMarioStateExtras = gMarioStateExtras,
    gCharData = gCharData,
    ACT_GROUND_POUND_A = ACT_GROUND_POUND_A,
    ACT_GROUND_POUND_B = ACT_GROUND_POUND_B
}

--hook_chat_command("health", "Set your health.", command_health)
if network_is_server() then
    --hook_chat_command("level", "Set your character.", command_character)
end


for i=0, MAX_PLAYERS-1 do
    hook_on_sync_table_change(gPlayerSyncTable[i], 'hp', i, on_health_changed)
end